function [Lp, VAudioOut] = CalibrateLevels(handles)

% Lp - Soundpressure (dB re 1 uPa@1m)
% Su - Transmitter sensitivity (dB re uPa/V @ 1m)
% VaudioIn - voltage into soundcard (dB re V)
% VaudioOut - Voltage from soundcard
% M - receiver sensitivity (dB re V/uPa)
% DiffAttAudioIn = AttUTB-AudioIn = 51dB
% DiffAttAudioOut = AttAudioOut-UTB = 58 dB
% Fc - Carrier Frequency
% TransducerSensitivity - dataset of transducer data

%Fc=handles.Fc;


Su = handles.transducerSensitivity;
DiffAttAudioIn=51; %dB
DiffAttAudioOut=58; %dB

% Calculation from Voltage to uPa
Lp = Su + VAudioIn + DiffAttAudioIn;

% Calculation from uPa to Voltage
VAudioOut = M + Lp + DiffAttAudioOut;

