%% Test Latency Calibration for many samples per frame
function CalibrationFunction (menu5)

global samplesDelay minDist peaksDetected ms SamplesPerFrame filnam
for ttt =1:1 
% clear all, close all, clc
fs = menu5.import_paramters.settings.Fs;
% fs = 44100;
name = menu5.import_paramters.settings.soundcard;
InCh = menu5.CalibrationInputCh;
OutCh = menu5.CalibrationOutputCh;

numberChannels = max([InCh OutCh]); %% Number of channels active 

% testNumber = 7;%7; % MAX BUFFER ETC FOR dsp.Audio is 65536 which is 7 here
% testNumberNext = 6;%6; % .. and 6 here
% SamplesPerFrame = (2.^(1:testNumber)).*512;
% % SamplesPerFrame = (2.^(1:testNumberNext)).*768;
% 
% SamplesPerFrame = [SamplesPerFrame,(2.^(1:testNumberNext)).*768];
% SamplesPerFrame = sort(SamplesPerFrame);
% SamplesPerFrame = 16*1024*2;
SamplesPerFrame = [1024,1536,2048,4096,6144,8192,12288,16384,32768,65536];
% SamplesPerFrame = ones(10,1)*1536;
testNumber = length(SamplesPerFrame);
samplesDelay = zeros(1,testNumber);
minDist = zeros(1,testNumber);
peaksDetected = zeros(1,testNumber);
ms = zeros(1,testNumber);

actpath = cd;
cd([actpath '\CalibrationResults']);
str = [filnam name 'CalibratedValues.txt'];
seconds =3;
fileID = fopen(str,'w');

str = sprintf('This may take a few minutes... \n Please wait...');
h = waitbar(0,str);
for n = 1:testNumber
    cd(actpath);
    [samplesDelay(n),minDist(n),peaksDetected(n),ms(n)] = ...
        latencyCalibration(SamplesPerFrame(n),fs,name,numberChannels, InCh, OutCh,seconds);
    cd([actpath '\CalibrationResults']);
    tt = num2str(round((n/(testNumber)*100)));
    str = ['This may take a few minutes... \n','Calibrating... ' tt, '%% done'];
    str = sprintf(str);
    waitbar(n/(testNumber),h,str)
    fprintf(fileID,'*********************************************** \n');
    fprintf(fileID,'*********************************************** \n');
    fprintf(fileID,'Sampling frequency: ');
    fprintf(fileID,'%i \n',fs);
    fprintf(fileID,'SoundCard Number of channels: ');
    fprintf(fileID,'%i \n',numberChannels);
    fprintf(fileID,'Samples per frame : ');
    fprintf(fileID,'%i \n',SamplesPerFrame(n));
    fprintf(fileID,'----------------------------------------------- \n');
    fprintf(fileID, 'Latency in ms is  : ');
    fprintf(fileID,'%0.2f \n',ms(n));
    fprintf(fileID, 'Latency in samples is : ');
    fprintf(fileID,'%i \n',samplesDelay(n));
    fprintf(fileID, 'Minimum distance is : ');
    fprintf(fileID,'%0.2f \n',minDist(n));
    fprintf(fileID, 'Validation of results : ');
    fprintf(fileID,'%i \n \n \n',peaksDetected(n));
end
waitbar(1,h,'Finished 100%')
pause(0.5)
close(h)

fclose(fileID);
cd(actpath)
end