function RealTimeTest(handles,hObject)
% RealTime - function for running real time audio signal processing
% 
% This function runs an infinite loop accessing audio signals in real time
% See "headerRealTime.m", for decleration of the parameters.
%
% Last modified 09.12.2014 by
% Frank Hetland & Leo Hauge

global forever attTrue nSampl propTrue reflections pathGUI pathFunc filnam

if forever==0,
    % Toggle Pushbutton
    pause(0.0001)
    forever = 1;
    set(handles.Realtime,'String','Stop Main Loop');
    set(handles.Realtime,'BackgroundColor',[0.9 0.4 0.4]);
    pause(0.0001)
else
    % Toggle Pushbutton
    pause(0.0001)
    forever = 0;
    set(handles.Realtime,'String','Start Main Loop');
    set(handles.Realtime,'BackgroundColor',[0.639 0.91 0.651]);
    pause(0.0001)
end
%% import parameteres from matlab script

headerRealTime



cd (pathGUI)

AFWOut = dsp.AudioFileWriter([filnam 'Out.wav'],'FileFormat', 'WAV');
AFWOut.SampleRate =Fs;
AFWIn = dsp.AudioFileWriter([filnam 'In.wav'],'FileFormat', 'WAV');
AFWIn.SampleRate =Fs;


if forever
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('***********        Now running the emulator        ***********')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
else
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('***********        Not running the emulator        ***********')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
    disp('**************************************************************')
end

%% Pick out reflections with 20 dB less amplitude than max amplitude
% amplitudeLimitSelection

% b = channelMatrix(handles);
b = handles.settings.matrix;
[leng,update] = size(b{1});

frameZero = zeros(fSize,nodes);
signalChannel = zeros(leng+fSize-1,node);
out = zeros(fSize,nodes);
teller = 0;
% SoundCard GAIN, adjusted for equally strong signal in as out
adjustedGain = 198/18.0;
% testSignal = [];
if (mod(propTrue,2)==1)
else
    while forever,
        pause(0.000002)
        teller = rem(teller,update)+1;
        % read audio
        in = adjustedGain.*step(Mic);
        step(AFWIn,in(:,1));
        
        signalChannel(:,1) = signalChannel(:,1) + conv(in(:,2),b{1}(:,teller));
        signalChannel(:,2) = signalChannel(:,2) + conv(in(:,1),b{1}(:,teller));
        
        
        out(:,1) = signalChannel(1:fSize,1);
        out(:,2) = signalChannel(1:fSize,2);
        
        signalChannel = [signalChannel;frameZero];
%       send out audio        
        step(Speaker, out)  
%         To record to file
         step(AFWOut,out);
    end % end of real-time loop
end
 % if

release(Mic)
release(Speaker)
release(AFWOut)
