function [b,Inte] = channelMatrix(handles)

global SamplesPerFrame samplesDelay
headerRealTime
rxPos = handles.class1.nodesChannel;
Inte = 0;
ifDoppler = handles.statement.DopplerSpread;
ifAbsorption = handles.statement.absorption;

frame = handles.settings.samplesPerFrame;

indx = find(SamplesPerFrame == frame);


% use the wave height and seastate from headerRealTime to find the wind
% speed. The windspeed is taken from SEASTATE in links
waveMax = [0, 0.1, 0.5, 1.25, 2.5, 4, 6, 9, 14, 18];
U = [0 1.5 3.3 5.4 7.9 10.7 24.4 28.4 32.6 32.6*18/14];
U = U.*waveHeight./waveMax;
U(1) = 0.1;

% Number of coefficients in water absorption filter
nCoef = 31;

b{nChannels} = 0;
doppMat{nChannels} = 0;
index{nChannels} = 0;
maxDopp = zeros(nChannels,1);
maxDelay = zeros(nChannels,1);
samples = zeros(nChannels,1);




if (ifDoppler == 1) && (ifAbsorption == 1)
%     % use the wave height and seastate from headerRealTime to find the wind
%     % speed. The windspeed is taken from SEASTATE in links
%     waveMax = [0, 0.1, 0.5, 1.25, 2.5, 4, 6, 9, 14, 18];
%     U = [0 1.5 3.3 5.4 7.9 10.7 24.4 28.4 32.6 32.6*18/14];
%     U = U.*waveHeight./waveMax;
%     U(1) = 0.1;
%     
%     % Number of coefficients in water absorption filter
%     nCoef = 31;
%     
%     b{nChannels} = 0;
%     doppMat{nChannels} = 0;
%     index{nChannels} = 0;
%     maxDopp = zeros(nChannels,1);
%     maxDelay = zeros(nChannels,1);
%     samples = zeros(nChannels,1);
    for n = 1:nChannels % Multipath channels
        % Create doppler spread matrix
        [r,index{n}] = rangesDopplerSpread(Narr{n},SrcAngle{n},RcvrAngle{n},...
            NumTopBnc{n},NumBotBnc{n},txPos,rxPos(n,3),depth);
        [doppMat{n},I] = dopplerSpread(Fs,U(seaState+1),r,cmean,fc,SrcAngle{n},RcvrAngle{n},BW, fSize);
        if length(Inte)<length(I)
            Inte = I;
        end
        % find the maximum number of samples in the scatter matrix
        tempNarr = length(doppMat{n});
        for m = 1:tempNarr
            [upDate,tempMax] = size(doppMat{n}{m});
            if tempMax>maxDopp(n)
                maxDopp(n) = tempMax;
            end
        end
        
        % find max delay of all reflections for all multipaths
        tempNarr = Narr{n};
        tempDelay = delay{n};
        tempMaxDelay = max(tempDelay(1:tempNarr));
        
        if (maxDelay(n)<tempMaxDelay)
            maxDelay(n) = tempMaxDelay;
        end
        
        % samples of maximum delay - system delay
        samples(n) = round(maxDelay(n)*Fs)-samplesDelay(indx);
        
        samples(n) = samples(n)+nCoef+maxDopp(n);
        % create an array to convolve the input signal with to add delay
        b{n} = zeros(samples(n),upDate);
        
    end    
    for m = 1:nChannels % multipaths
        tempDelay = delay{m};
        tempAmp = amp{m};
        tempNarr = Narr{m};
        teller = 1;
        for n = 1:tempNarr % reflections
            coef = designAbsorptionFilter(tempDelay(n)*cmean,Fs,temp,cmean,depth);
            inToB = coef;
            leng = length(inToB)-1;
            if ( index{m}(n) == n )
                tempDop = doppMat{m}{teller};
                
                for i = 1:upDate
                    inToB = conv(coef,tempDop(i,:));
                    leng = length(inToB)-1;
                    
                    a = round(tempDelay(n)*Fs)-samplesDelay(indx);
                    b{m}(a:a+leng,i) = b{m}(a:a+leng,i) + ...
                        (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
                end
                teller = teller+1;
%                 if teller> length(index{m})
%                     teller = length(index{m});
%                 end
            else
                for i = 1:upDate
                    a = round(tempDelay(n)*Fs)-samplesDelay(indx);
                    b{m}(a:a+leng,i) = b{m}(a:a+leng,i) + ...
                        (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
                end
            end
        end
    end
elseif (ifDoppler == 0) && (ifAbsorption == 1)
%     % Number of coefficients in water absorption filter
%     nCoef = 31;
%     
%     
%     doppMat{nChannels} = 0;
%     index{nChannels} = 0;
%     b{nChannels} = 0;
%     maxDopp = zeros(nChannels,1);
%     maxDelay = zeros(nChannels,1);
%     samples = zeros(nChannels,1);
    for n = 1:nChannels % Multipath channels
        % find max delay of all reflections for all multipaths
        tempNarr = Narr{n};
        tempDelay = delay{n};
        tempMaxDelay = max(tempDelay(1:tempNarr));
        
        if (maxDelay(n)<tempMaxDelay)
            maxDelay(n) = tempMaxDelay;
        end
        
        % samples of maximum delay - system delay
        samples(n) = round(maxDelay(n)*Fs)-samplesDelay(indx);
        
        samples(n) = samples(n)+nCoef;
        % create an array to convolve the input signal with to add delay
        b{n} = zeros(samples(n),1);
    end
    
    for m = 1:nChannels % multipaths
        tempDelay = delay{m};
        tempAmp = amp{m};
        tempNarr = Narr{m};
        for n = 1:tempNarr % reflections
            coef = designAbsorptionFilter(tempDelay(n)*cmean,Fs,temp,cmean,depth);
            inToB = coef;
            leng = length(inToB)-1;
            a = round(tempDelay(n)*Fs)-samplesDelay(indx);
            b{m}(a:a+leng,1) = b{m}(a:a+leng,1) + ...
                (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
        end
    end

elseif (ifDoppler == 1) && (ifAbsorption == 0)
    for n = 1:nChannels % Multipath channels
        % Create doppler spread matrix
        [r,index{n}] = rangesDopplerSpread(Narr{n},SrcAngle{n},RcvrAngle{n},...
            NumTopBnc{n},NumBotBnc{n},txPos,rxPos(n,3),depth);
        [doppMat{n},I] = dopplerSpread(Fs,U(seaState+1),r,cmean,fc,SrcAngle{n},RcvrAngle{n},BW, fSize);
        if length(Inte)<length(I)
            Inte = I;
        end
        % find the maximum number of samples in the scatter matrix
        tempNarr = length(doppMat{n});
        for m = 1:tempNarr
            [upDate,tempMax] = size(doppMat{n}{m});
            if tempMax>maxDopp(n)
                maxDopp(n) = tempMax;
            end
        end
        
        % find max delay of all reflections for all multipaths
        tempNarr = Narr{n};
        tempDelay = delay{n};
        tempMaxDelay = max(tempDelay(1:tempNarr));
        
        if (maxDelay(n)<tempMaxDelay)
            maxDelay(n) = tempMaxDelay;
        end
        
        % samples of maximum delay - system delay
        samples(n) = round(maxDelay(n)*Fs)-samplesDelay(indx);
        
        samples(n) = samples(n)+maxDopp(n);
        % create an array to convolve the input signal with to add delay
        b{n} = zeros(samples(n),upDate);
        
    end    
    for m = 1:nChannels % multipaths
        tempDelay = delay{m};
        tempAmp = amp{m};
        tempNarr = Narr{m};
        teller = 1;
        for n = 1:tempNarr % reflections
            if ( index{m}(n) == n )
                tempDop = doppMat{m}{teller};
                
                for i = 1:upDate
                    inToB = tempDop(i,:);
                    leng = length(inToB)-1;
                    
                    a = round(tempDelay(n)*Fs)-samplesDelay(indx);
                    b{m}(a:a+leng,i) = b{m}(a:a+leng,i) + ...
                        (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
                end
                teller = teller+1;
%                 if teller> length(index{m})
%                     teller = length(index{m});
%                 end
            else
                for i = 1:upDate
                    a = round(tempDelay(n)*Fs)-samplesDelay(indx);
                    b{m}(a,i) = (abs(tempAmp(n))*sign(real(tempAmp(n))));
%                     b{m}(a:a+leng,i) = b{m}(a:a+leng,i) + ...
%                         (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
                end
            end
        end
    end
else
%     doppMat{nChannels} = 0;
%     index{nChannels} = 0;
%     b{nChannels} = 0;
%     maxDopp = zeros(nChannels,1);
%     maxDelay = zeros(nChannels,1);
%     samples = zeros(nChannels,1);
    for n = 1:nChannels % Multipath channels
        % find max delay of all reflections for all multipaths
        tempNarr = Narr{n};
        tempDelay = delay{n};
        tempMaxDelay = max(tempDelay(1:tempNarr));
        
        if (maxDelay(n)<tempMaxDelay)
            maxDelay(n) = tempMaxDelay;
        end
        
        % samples of maximum delay - system delay
        samples(n) = round(maxDelay(n)*Fs)-samplesDelay(indx);
        
%         samples(n) = samples(n)+nCoef;
        % create an array to convolve the input signal with to add delay
        b{n} = zeros(samples(n),1);
    end
    
    for m = 1:nChannels % multipaths
        tempDelay = delay{m};
        tempAmp = amp{m};
        tempNarr = Narr{m};
        for n = 1:tempNarr % reflections      
            a = round(tempDelay(n)*Fs)-samplesDelay(indx);
            b{m}(a,1) = b{m}(a,1) + ...
                (abs(tempAmp(n))*sign(real(tempAmp(n))));
            
        end
    end
end %ifDoppler and ifAbsorption

nNode = handles.settings.nodes;
matB{nNode,nNode} = 0;
count1 = 0;
for i = 1:nNode
    for j = 1:nNode
        matB{i,i}=0;
        if (i<j)
            count1 = count1+1;
            matB{i,j}= b{count1};
            matB{j,i}= b{count1};
        end 
    end
end
clear b
b = matB;
clear matB
 





