function [x,z]=createSeabed(shape,range,depth,handles)
% A funtion creating a sea bed shape from different cases
% Case 0: Flat
% Case 1: A slowly varying sine
% Case 2: A rapidly varying sine
% Case 3: A gaussian distributed
% Case 4: A linear decreasing
% Case 5: A linear increasing 
% Case 10: Freehand draw
global filnam
heightSeabedChange=handles.settings.heightSeabedChange;
% depthRx=handles.class1.depthSeabedRx;

range=range/1000;
switch shape
    case 0 % Flat
        x = linspace(0,range,101);
        z = linspace(depth,depth,101);
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
    case 1 % A slowly varying sine
%         figure
        t = linspace(0,3*pi,101);
        x = linspace(0,range,101);
        z = cos(t)*depth/6+depth-depth/6;
%         plot(x,y)
%         axis ij
%         ylim([0 depth])
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
    case 2 % Case 2: A rapidly varying sine

%         figure
        t = linspace(0,20*pi,101);
        x = linspace(0,range,101);
        z = sin(t)*depth/15+depth-depth/15;
%         plot(x,y)
%         axis ij
%         ylim([0 depth])
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
        
    case 3 % Case 3: A gaussian distributed

%         figure
        x = linspace(0,handles.class1.HorizontalRxMax/1000,101);
        p(1) = (handles.class1.HorizontalRxMax/1000)/5;
        p(2) = (handles.class1.HorizontalRxMax/1000)/2;
        z=gaussmf (x,p)*depth/3 + depth-depth/3;
        newHorizontalRXPos = min(find(x>=range));
        z=interp1(z,linspace(1,newHorizontalRXPos,101));
        x=linspace(0,x(newHorizontalRXPos),101);
%         plot(x,y)
%         ylim([0 depth])
%         axis ij
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
        
    case 4 % Case 4: A linear decreasing
% % %         heightSeabedChange=20;
% % % %         figure
% % %         x = linspace(0,handles.class1.HorizontalRxMax/1000,101);
% % %         z = linspace(0,heightSeabedChange,101)+depth-heightSeabedChange; 
% % %         newHorizontalRXPos = min(find(x>=range));
% % %         z=interp1(z,linspace(1,newHorizontalRXPos,101));
% % %         x=linspace(0,x(newHorizontalRXPos),101);
        
%         plot(x,y)
%         ylim([0 depth])
%         axis ij



        heightSeabedChange=20; % [m], height change in seabed
        % Create the x-axis with 10 000 datapoints
        x = linspace(0,handles.class1.HorizontalRxMax/1000,10000);
        % Create the z-axis with 10 000 datapoints
        z = linspace(0,heightSeabedChange,10000)+depth-heightSeabedChange;
        % Finds the Horizontal Position of TX
        newHorizontalTXPos = min(find(x>=handles.class1.HorizontalTx/1000));
        % Finds the Horizontal Position of RX
        newHorizontalRXPos = min(find(x>=abs(range)));
        % Seperate the position between TX and RX in height, and
        % interpolate it with the correct amount of samples: 101
        z=interp1(z,linspace(newHorizontalTXPos,newHorizontalRXPos,101));
        
%         x=linspace(x(newHorizontalTXPos),x(newHorizontalRXPos),101);

        % Change the starting point in horizontal axes from 0 to RX, Bellhop
        % starts allways at 0.
        x = linspace(0,handles.class1.RealDistanceRX/1000,101);
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
    case 5 % Case 5: A linear increasing 
        
        heightSeabedChange=20; % [m], height change in seabed
        % Create the x-axis with 10 000 datapoints
        x = linspace(0,handles.class1.HorizontalRxMax/1000,10000);
        % Create the z-axis with 10 000 datapoints
        z = linspace(heightSeabedChange,0,10000)+depth-heightSeabedChange;
        % Finds the Horizontal Position of TX
        newHorizontalTXPos = min(find(x>=handles.class1.HorizontalTx/1000));
        % Finds the Horizontal Position of RX
        newHorizontalRXPos = min(find(x>=abs(range)));
        % Seperate the position between TX and RX in height, and
        % interpolate it with the correct amount of samples: 101
        z=interp1(z,linspace(newHorizontalTXPos,newHorizontalRXPos,101));
        
%         x=linspace(x(newHorizontalTXPos),x(newHorizontalRXPos),101);

        % Change the starting point in horizontal axes from 0 to RX, Bellhop
        % starts allways at 0.
        x = linspace(0,handles.class1.RealDistanceRX/1000,101);

        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');

        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
    case 10
        HorizontalMax=max(handles.class1.nodesPosition(:,1)); 
        x = handles.settings.handdrawX/1000;
        z = handles.settings.handdrawZ; 
        PosXend=max(find(x==max(x)));
        x(1:2)=0;
        if max(x)>HorizontalMax
            PosXend=min(find(x>=HorizontalMax));
        else
            PosXend=max(find(x==max(x)));
            x(PosXend:(PosXend+(PosXend/4)))=linspace(max(x),range,PosXend/4+1);
            z(PosXend:(PosXend+(PosXend/4)))=linspace(0,0,PosXend/4+1);
            PosXend=length(x);
        end
       
        x = interp1(x,linspace(1,PosXend,101));
        z = depth-interp1(z,linspace(1,PosXend,101));
        
         UnderDepthPos=find(z>depth);
        for i=1:length(UnderDepthPos)
            z(UnderDepthPos(i))=depth;
        end
        
        cd MakedFile
        fid = fopen([filnam '.bty'], 'w');
        
        fprintf(fid, '''%s''\n', 'L');
        fprintf(fid, '%i \n', 101);
        for i = 1:101
            fprintf(fid, '\t %f \t %f \n', x(i),z(i));
        end
        fclose(fid);
        cd ..
end

end