function filterCoef = designAbsorptionFilter(range,fs,temp,c,depth)
%% M TA INN HANDLES
% range is in meters, must be in km.
rangekm = range/1000;
% Sampling rate
% fs = 96000;
% Filter order (30 seems good enough in the frequency range)
resFilt = 30;
% Empty matrix for absorption coefficients
alpha = zeros(1,resFilt);
% Carrier frequency
fc = fs/4;
% Bandwidth (Must be the whole bandwidth 0 to fs/2)
bandWidth = fs/2;
% Frequencies to insert in calculating absorption coefficients
freq1 = linspace(fc-bandWidth/2,fc+bandWidth/2,resFilt);
% Compute the water absorption coefficients for 30 equally distributed
% frequencies over the whole frequency bandwidth
for i = 1:resFilt
    alpha(i) = rangekm*(waterAbsorptionCoefficient(freq1(i),temp,c,depth));
end
% Absorption coefficients are in dB. Must be in scalar values
alpha = 10.^(alpha/20);
alpha = 1./alpha;
% Normalized frequency [0,1]
f = freq1./(fs/2);
% Produce the filter coefficients
filterCoef = fir2(resFilt,f,alpha);

% %% Use to illustrate absorption of a signal
% b = filterCoef;
% 
% figure(3);
% b = fir2(resFilt,f,alpha);
% [h,w] = freqz(b,1,2^nextpow2(resFilt));
% % subplot(3,1,1)
% plot(freq1,20*log10(alpha),w/pi*(fs/2),20*log10(abs(h)))
% xlabel('Frequency - Hz')
% ylabel('Magnitude in dB')
% legend('Ideal','Designed filter')
% legend boxoff
% % title('Comparison of Frequency Response Magnitudes')
% 
% hfig = figure(3);
% set(hfig,'position',[600 400 600 300])

% 
% 
% figure(4);
% b = fir2(resFilt,f,alpha);
% [h,w] = freqz(b,1,2^nextpow2(resFilt));
% % subplot(3,1,1)
% plot(w/pi*(fs/2),20*log10(abs(h)))
% xlabel('Frequency - Hz')
% ylabel('Magnitude in dB')
% legend('Absorption filter')
% legend boxoff
% % % title('Comparison of Frequency Response Magnitudes')
% % 
% hfig = figure(4);
% set(hfig,'position',[600 400 600 300])

% figure;
% t = 0:1/fs:1;
% sin1 = sin(2*pi*2500.*t);
% sin5 = sin(2*pi*5000.*t);
% sin2 = sin(2*pi*10000.*t);
% sin3 = sin(2*pi*20000.*t);
% sin4 = sin(2*pi*30000.*t);
% y = sin1 + sin2 +sin3 + sin4 + sin5;
% 
% sin1 = sin(2*pi*25000.*t);
% sin5 = sin(2*pi*23000.*t);
% sin2 = sin(2*pi*19000.*t);
% sin3 = sin(2*pi*21000.*t);
% sin4 = sin(2*pi*20500.*t);
% y =y+ sin1 + sin2 +sin3 + sin4 + sin5;
% 
% 
% yy = rand(1,10*fs);
% y2 = filter(b,1,y);
% yy2 = filter(b,1,yy);
% 
% nfft = 2^nextpow2(length(y));
% Y = fft(y,nfft);
% Y = Y(1:nfft/2+1);
% psdx = (1/(fs*nfft)) * abs(Y).^2;
% psdx(2:end-1) = 2*psdx(2:end-1);
% freq = 0:fs/nfft:fs/2;
% 
% subplot(3,1,2)
% plot(freq,(10*log10(psdx)))
% grid on
% title('Magnitude Response Using FFT')
% xlabel('Frequency (Hz)')
% ylabel('Power/Frequency (dB/Hz)')
% ylim([-40 0])
% nfft = 2^nextpow2(length(y2));
% Y2 = fft(y2,nfft);
% Y2 = Y2(1:nfft/2+1);
% psdx = (1/(fs*nfft)) * abs(Y2).^2;
% psdx(2:end-1) = 2*psdx(2:end-1);
% freq = 0:fs/nfft:fs/2;
% subplot(3,1,3)
% plot(freq,10*log10(psdx))
% grid on
% title('Magnitude Response Using FFT')
% xlabel('Frequency (Hz)')
% ylabel('Power/Frequency (dB/Hz)')
% ylim([-70 0])
% 
% 
% figure
% b = fir2(resFilt,f,alpha);
% [h,w] = freqz(b,1,2^nextpow2(resFilt));
% subplot(3,1,1)
% plot(freq1,alpha,w/pi*(fs/2),abs(h))
% xlabel('Normalized Frequency (\times\pi rad/sample)')
% ylabel('Magnitude')
% legend('Ideal','fir2 designed')
% legend boxoff
% title('Comparison of Frequency Response Magnitudes')
% 
% 
% nfft = 2^nextpow2(length(yy));
% Y = fft(yy,nfft);
% Y = Y(1:nfft/2+1);
% psdx = (1/(fs*nfft)) * abs(Y).^2;
% psdx(2:end-1) = 2*psdx(2:end-1);
% freq = 0:fs/nfft:fs/2;
% 
% 
% 
% subplot(3,1,2)
% plot(freq,(10*log10(psdx)))
% grid on
% title('Magnitude Response Using FFT')
% xlabel('Frequency (Hz)')
% ylabel('Power/Frequency (dB/Hz)')
% ylim([-60 0])
% nfft = 2^nextpow2(length(yy2));
% Y2 = fft(yy2,nfft);
% Y2 = Y2(1:nfft/2+1);
% psdx = (1/(fs*nfft)) * abs(Y2).^2;
% psdx(2:end-1) = 2*psdx(2:end-1);
% freq = 0:fs/nfft:fs/2;
% subplot(3,1,3)
% plot(freq,10*log10(psdx))
% grid on
% title('Magnitude Response Using FFT')
% xlabel('Frequency (Hz)')
% ylabel('Power/Frequency (dB/Hz)')
% ylim([-70 0])