%% For use with GUI
% function samplesDelay = latencyCalibration(handles)
% SamplesPerFrame = handles.settings.samplesPerFrame;
% Fs = handles.settings.Fs;
% SoundCard = handles.settings.soundcard;
% nChannels = handles.settings.numbOfInOut;

%% For use with test
function [samplesDelay, minDist, peaksDetected,ms] = latencyCalibration(SamplesPerFrame,Fs,SoundCard,nChannels, input, output,seconds)
%% Create objects for real-time audio fetch
[speaker, mic] = CreateSpeakerAndMic(SoundCard, Fs, SamplesPerFrame, nChannels);
filnam = 'caliSignal1';
AFW = dsp.AudioFileWriter([filnam '.wav'],'FileFormat', 'WAV');
AFW.SampleRate = Fs;
samplesDelay=0; minDist=0; peaksDetected = 0;
%% Create testsignal
% number of seconds to analyze
ms  = 0;
if SamplesPerFrame > 16384
    Fs = Fs*ceil(SamplesPerFrame/16384);
end
% seconds = 5;
xx = zeros(Fs,1);
xx(Fs/2,1) =1;
x = zeros(seconds*Fs,1);

for i = 1:seconds
    start = (i-1)*Fs;
    stop = i*Fs;
    x(1+start:stop,1) = xx(1:Fs,1);
end
b = fir1(10,0.1);
x = filter(b,1,x);
maxi = max(abs(x));
x = x./maxi;

%% Run the testsignal
% number of runs through the loop
numPeak = round(Fs/SamplesPerFrame*seconds);

% Real-time audio 
counter = 0;
% start = (counter-1)*SamplesPerFrame;
% stop = counter*SamplesPerFrame;
while counter < numPeak-1;
    pause(0.000002)
    counter = counter+1;
    start = (counter-1)*SamplesPerFrame;
    stop = counter*SamplesPerFrame;
    
    
    in = step(mic);
    in(1:SamplesPerFrame,output) = x(1+start:stop,1);
    step(speaker,in);
    fileWrite(:,2) = in(:,input);
    fileWrite(:,1) = in(:,output);
    step(AFW,fileWrite);

end
pause(0.1)
release(mic)
release(speaker)
release(AFW)

% toc(start)
disp('Finished sampling Audio')
% start = tic;
%% Read the signals
% filnam = 'caliSignal3';
[signal,fsread] = audioread([filnam '.wav']);
inputMax = max(abs(signal(:,1)));
outputMax = max(abs(signal(:,2)));
signal(:,1) = signal(:,1)./inputMax;
signal(:,2) = signal(:,2)./outputMax;
localMax = find(signal(:,1)>0.9);
localMax2 = find(signal(:,2)>0.9);
localMax = localMax -Fs/2;
localMax2 = localMax2 -Fs/2;
localMaxEasy = rem(localMax,Fs);
localMax2Easy = rem(localMax2,Fs);



samplesDelayEasy = round(mean(localMax2Easy))-round(mean(localMaxEasy));
if samplesDelayEasy<0
    samplesDelayEasy = localMaxEasy - samplesDelayEasy;
end
% ms = samplesDelay/fsread*1000;
% minDist = ms*1.54; % given a sound speed of 1540 m/s
% peaksDetected = 1;
% normalizing signal
% inputMax = max(abs(signal(:,1)));
% outputMax = max(abs(signal(:,2)));
% signal(:,1) = signal(:,1)./inputMax;
% signal(:,2) = signal(:,2)./outputMax;

% figure; plot(signal)
% toc(start)

disp('Finished filtering')
% start = tic;
%% Peak detection
localMax = [];
localMax2 = [];
threshold = 10;
[a,b] = size(signal);
i = (threshold);
while i<a-(threshold+1) %for i = threshold+1:a-(threshold+1)
    i = i+1;
    if (signal(i,1)>signal(i-threshold:i-1,1))
        if (signal(i,1)>signal(i+1:i+threshold,1))
            if (signal(i,1)>0.9)
                localMax = [localMax;i];
                i = i+Fs-200;
            end
        end
    end
end
i = (threshold);
while i<a-(threshold+1) %for i = threshold+1:a-(threshold+1)
    i = i+1;
    if (signal(i,2)>signal(i-threshold:i-1,2))
        if (signal(i,2)>signal(i+1:i+threshold,2))
            if(signal(i,2)>0.9)
                localMax2 = [localMax2;i];
                i = i+Fs-200;
            end
        end
    end
end
% toc(startC)


a = min([length(localMax),length(localMax2)]);
if a == 0
%     samplesDelay=0; minDist=0; peaksDetected = 0;
    disp('No peaks detected!')
    return
end

disp('Finished peak detection')
% startC = tic;
%% Establish certanity of peak value detection
localMax = rem(localMax,Fs);
localMax2 = rem(localMax2,Fs);


% Min and max values
mini = min(localMax);
mini2 = min(localMax2);
maxi = max(localMax);
maxi2 = max(localMax2);

a = min([length(localMax),length(localMax2)]);

% Check if all peak values are approx. at the same distance from each other
% for the transmitted signal
if (maxi-mini)>20
    tempL=[];
    tempL2=[];
    for i = 1:a
        if (localMax(i)~=mini)&&(localMax(i)~=maxi)
            tempL = [tempL;localMax(i)];
        end
        if (localMax2(i)~=mini2)&&(localMax2(i)~=maxi2)
            tempL2 = [tempL;localMax2(i)];
        end
    end
    localMax = tempL;
    localMax2 = tempL2; 
end

% toc(startC)
a = min([length(localMax),length(localMax2)]);
if a == 0
%     samplesDelay=0; minDist=0; peaksDetected = 0;
    disp('Not enough peaks detected!\n Please run Again')
    return
end
disp('Finished peak seperating maximums.')

%% Check if file is not good enough

meanIn = mean(localMax);
meanOut = mean(localMax2);

teller1 = 0;
for i = 1:length(localMax)
    if abs(localMax(i)- meanIn)>1000
        teller1 = teller1+1;
    end
end
if teller1 > 1
%     samplesDelay=0; minDist=0; peaksDetected = 0;
    disp('Please run simulations again, bad file.....')
    return;
end
teller1 = 0;
for i = 1:length(localMax2)
    if abs(localMax2(i)- meanOut)>1000
        teller1 = teller1+1;
    end
end
if teller1 > 1
%     samplesDelay=0; minDist=0; peaksDetected = 0;
    disp('Please run simulations again, bad file.....')
    return;
end


%% Calculate latency
a = min([length(localMax),length(localMax2)]);  
samplesDiff = localMax2(1:a)-localMax(1:a);
samplesDiff = rem(samplesDiff,Fs);
for i = 1:length(samplesDiff)
    if sign(samplesDiff(i)) == -1
        samplesDiff(i)=Fs+samplesDiff(i); 
    end
end
sampleDiff = round(mean(samplesDiff));
samplesDelay = sampleDiff-1;
% fprintf('Latency in samples is %d \n',sampleDiff)

ms = round(100000*sampleDiff/fsread)/100;
% fprintf('Which is %0.2f ms latency \n',ms)
% figure; plot(signal)


% sampleDiff = round(mean(samplesDiff));
% samplesDelay = sampleDiff;
minDist = round(1540*sampleDiff/fsread*100)/100;
% fprintf('Latency in samples is %d \n',sampleDiff)
% fprintf('Which is %d ms latency \n',round(1000*sampleDiff/fs))
% fprintf('The minimum range is %d \n', minDist)
% fprintf('If the reseivers are closer, \n please move the receivers and ')
% fprintf('run \n calibration again for accurate measurements \n')
% figure;plot(signal)
% check if number of peaks detected are the same for both channels
if length(localMax) == length(localMax2)
    peaksDetected = 1;
elseif ms >500 
    peaksDetected = 1;
else 
    peaksDetected = 0;
end

% check whether or not the easy detection produces the same result as the
% harder one
if  0.95<(samplesDelayEasy/samplesDelay) && 1.05>(samplesDelayEasy/samplesDelay)
    peaksDetected = 1;
end

str2 = [filnam '.wav'];
delete(str2);
pause(0.1)






