function plotfunction(handles)
% plotfunction - function for plotting
% 9 CASES:
% - Impulse response
% - Frequency response ( NEED AUDIORECORD), look at recorded data freq
% domain
% - Ambient noise
% - Reflectionloss
% - Waterabsorption
% - Intensity Raytracing
% - Recorded Data (NEED AUDIORECORD) , look at recorded data in time domain 
% - Transducer Directivity, look at the directivity from the transducer 
% - Doppler Spread, look at the 
% - Enviroment variation (TX & RX)



% Last modified 09.12.2014 by
% Frank Hetland & Leo Hauge


global caseswitch filnam pathFunc pathGUI
disp(caseswitch)


X=find(caseswitch==1);
headerRealTime
for i=1:length(X)
    switch X(i)
        
        case 1 
            %% Impulse Response 
          
            % loading parameters
            global SamplesPerFrame samplesDelay
            
%             pulseLength = 1/500;
            hfig  = figure('name','Impuls Response');
            nodes = handles.settings.nodes;
            frame = handles.settings.samplesPerFrame;
            %%%%%%%%
            noise = handles.settings.noise;
%             VoltTrans=3.95; %[v]
%             MatlabLvl=0.3;
%             VoltGain =VoltTrans/MatlabLvl;
            %  2*0.01831 * VoltGain
            noise = noise.*(10^-6);
%             noise = noise./VoltGain;
%             noise = noise';
            nn = (nodes-1)*nodes/2;
            %%%%%%%%
            indx = find(SamplesPerFrame == frame);
            count = 0;
%             figure;
            for n = 1:nodes
                for m = 1:nodes
                    if n<m 
                        count = count+1;
                        tmpImp = handles.settings.matrix{n,m};
                        tmpImp = tmpImp(:,3);
                        z = zeros(samplesDelay(indx),1);
                        tmpImp = [z;tmpImp];
                        l = length(tmpImp);
%                         tmpImp=tmpImp+noise(1:l);
%                         tmpImp = [tmpImp;noise(1:l)];
%                         x = linspace(0,1000*2*l/Fs,2*l);
                        x = linspace(0,1000*l/Fs,l);
                        subplot(nn,1,count)
                        limit = delay{count};
                        minlimit = 1000*min(limit)-5;
                        maxlimit = 1000*max(limit)+15;
%                         tmpImp = 20*log10(abs(tmpImp./max(abs(tmpImp))));
                        plot(x,tmpImp)
                    end
            
                end
                ylim([-65 max(tmpImp)+10])
                xlim([minlimit, maxlimit])
                set(hfig,'position',[600 400 600 300])
                xlabel('Time - [ms]')
                ylabel('Normalized amplitude - [dB]')
                grid on
                datacursormode on
            end

        
        case 2 
            %% Frequency response 
            
            cd ('RecordedFiles')
            
            [yOut,fsOut]=audioread([filnam 'Out.wav']);
            [yIn,fsIn]=audioread([filnam 'In.wav']);
            figure('name','Input Frequency response');
            freqz(yIn(:,1))
            grid on
            
            figure('name','Output Frequency response');
            freqz(yOut(:,1))
            grid on
            

                
            cd (pathFunc)
            
        case 3 
            %% Ambient noise
   
            nfft = 2^nextpow2(Fs);
            AmbientN = fft(noise,nfft);
            AmbientN = AmbientN(1:nfft/2+1);
            AmbientNW = (1/(Fs*nfft)).*abs(AmbientN).^2;
            AmbientNW(2:end-1) = 2*AmbientNW(2:end-1);
            freq = 0:Fs/nfft:Fs/2;
            figure('name','Ambient Noise');
            semilogx(freq,10*log10(AmbientNW)); title('Power spectral density')
            xlim([100 Fs/2]);
            ylabel('Spectral level - dB re 1 \mu Pa, Hz');
            xlabel('freq [Hz]');
            grid on
            
%             figure;plot(noise.*10^(-6)); title('Pressure noise')
%             
%             figure;plot(noise./13.*10^(-6)); title('Pressure noise re MATLAB')
            
            
            
        case 4 
            %% Reflectionloss
            
            % BOUNCE ?? 
            
            
            c1 = mean(handles.settings.SSP); % m/s default soundspeed
            p1 = 1000; % kg/cm3 default density
            
            c2 = handles.settings.cBottom1; %m/s
            p2 = handles.settings.densBottom1*1000; %kg/cm3
            theta1 = 0:0.01:pi/2;
            
            for i = 1:length(theta1)
                theta2 = acos(c2/c1 * cos(theta1(i)));
                Rp(i) = (c2*p2*sin(theta1(i))-c1*p1*sin(theta2))/((c2*p2*sin(theta1(i))+c1*p1*sin(theta2)));
            end
            figure('name','Reflection Loss');
            % Rp
            angle= theta1.*180./pi;
            Tp = Rp +1;
            Rp = (Rp);
            % % plot (angle,Rp, 'LineWidth',2)
            % % hold on
            % % plot (angle, Tp, '-- black','LineWidth',2)
            % % hold off
            % % grid on
            
            % intesity
            Ir = abs(Rp).^2;
            It = 1 - Ir;
            % figure
            plot (angle,Ir)
            hold on
            plot (angle, It, '-- black')
            ylabel('Seabed Coef ');
            xlabel('Incident angle, degrees')
            legend('Reflection Coef', 'Transmission Coef')
            ylim([0 1.5])
            grid on
            
            
        case 5 
            %% Waterabsorption 
            % Absorption

            resFilt = 30;

            for i = 1:nChannels;
                % max  delay
                maxDelay = max(delay{i}(1:Narr{i}));
                minDelay = min(delay{i}(1:Narr{i}));
                [x,y] = find(delay{i}(1:Narr{i})==minDelay);
                % samples of maximum delay - system delay
                samples = round(maxDelay*Fs);
                samples = samples+31;
                % create an array to convolve the input signal with to add delay
                b = zeros(samples,1);
                
                
                % coefs = zeros(Narr,31);
                cmean = mean(c);
                % for # number of channels
                for n = 1:Narr{i}
                    coef = designAbsorptionFilter(delay{i}(n)*cmean,Fs,temp,cmean,depth);
                    coefs(n,:) = coef;
                    a = round(delay{i}(n)*Fs);
                    b(a:a+30) = abs(amp{i}(n)).*sign(real(amp{i}(n))).*coef;
                end
                freq = linspace(0,(Fs/2),resFilt);
                for m = 1:resFilt
                    alpha(m) = delay{i}(y)*cmean*(waterAbsorptionCoefficient(freq(m),temp,cmean,depth))/1000;
                end
                % Absorption coefficients are in dB. Must be in scalar values
                alpha = 10.^(alpha/20);
                alpha = 1./alpha;
                text = ['Waterabsorption Channel : ' num2str(i) ', Distance : ' num2str(rxPos(i,1)) 'm'];
                figure('name',text);
                
                % b = fir2(resFilt,f,alpha);
                [h,w] = freqz(coefs(y,:),1,2^nextpow2(resFilt));
                freq1 = linspace(0,(Fs/2)/1000,length(h));
                freq = linspace(0,(Fs/2)/1000,resFilt);
                subplot(3,1,1)
                plot(freq,20*log10(alpha),freq1,20*log10(abs(h)))
                xlabel('Frequency (kHz)')
                ylabel('Magnitude in dB')
                legend('Ideal','fir2 designed')
                legend boxoff
                title('Comparison of Frequency Filter Response')
                
                yy = rand(1,10*Fs);
                y2 = filter(coefs(y,:),1,y);
                yy2 = filter(coefs(y,:),1,yy);
                
                nfft = 2^nextpow2(length(yy));
                Y = fft(yy,nfft);
                Y = Y(1:nfft/2+1);
                psdx = (1/(Fs*nfft)) * abs(Y).^2;
                psdx(2:end-1) = 2*psdx(2:end-1);
                freq = 0:Fs/nfft:Fs/2;
                
                
                
                subplot(3,1,2)
                plot(freq,(10*log10(psdx)))
                grid on
                title('Magnitude Response Using FFT')
                xlabel('Frequency (Hz)')
                ylabel('Power/Frequency (dB/Hz)')
                ylim([-70 -30])
                nfft = 2^nextpow2(length(yy2));
                Y2 = fft(yy2,nfft);
                Y2 = Y2(1:nfft/2+1);
                psdx = (1/(Fs*nfft)) * abs(Y2).^2;
                psdx(2:end-1) = 2*psdx(2:end-1);
                freq = 0:Fs/nfft:Fs/2;
                subplot(3,1,3)
                plot(freq,10*log10(psdx))
                grid on
                title('Magnitude Response Using FFT')
                xlabel('Frequency (Hz)')
                ylabel('Power/Frequency (dB/Hz)')
                ylim([-70 -30])
            end
            

            
        case 6 
            %% intensity Raytracing 
            
            %%%% MOVE TO PLOT FUNCTION %%%%
            %%%%%  IKKE SLETT DETTE ! %%%%%
            %     if mod(intensityTrue,2)==1
            %         handles.settings.EnvOpt3='C';
            %         intensityTrue=1;
            %         writeEnvFiles(handles)
            %         cd (pathFunc)
            %         eval( [ '!' actpath '\bellhop.exe ' 'MakedFile\' filnam] )
            %         disp('***        Done        ***')
            %         disp('--------------------------')
            %         hold off
            %         plotshd([filename '.shd']);
            %
            %     else
            
        case 7 
            %% Recorded Data
            
            cd (pathGUI)
            [yOut,fsOut,nbits,opts]=wavread([filnam 'Out.wav']);
            [yIn,fsIn,nbits,opts]=wavread([filnam 'In.wav']);
            figure;
            plot(yOut)
            hold on
            plot(yIn)
            hold off
            grid on
            cd (pathFunc)
            
        case 8 
            %% Transducer Directivity
            
            if (strcmp(handles.t.filename, 'directivityTransducer.txt'))
                directivityData=handles.t.transducerData;
                [row,col]=size(directivityData);
                theta=linspace(-130,130,row*2-1);
                name=[];
                color=['r','b','g','bl','y','t','c'];
                figure
                for i=1:col-1
                    a = mod(i,length(color));
                    if a ==0
                        a = length(color);
                    end
                    transducer=directivityData(:,i+1)';
                    % to get the whole spectra from -90 to +90 degrees
                    transducer=[fliplr(transducer(1:end)), transducer(2:end)];
                    eval(['handles.t.transducer' handles.t.freq_name{i} '=transducer;']);
                    p{i}=polardb(theta,transducer,-30,3,color(i));
                    hold on
                    name=[name, ' ',handles.t.freq_name{i}];
                    title('Beam pattern to the transducer')
                    grid on
                    handles.statement.loadTrans=1;
                end
                
                name=strsplit(name(2:end));
                legend([p{1:length(p)}],name )
                hold off
            end
            
            
            
        case 9
            %% Doppler spread
            intensity = (handles.settings.intensity);
            tau = 1000.*linspace(0,length(intensity)/Fs,length(intensity));
            figure; plot(tau,intensity)
        case 10 
            %% Enviroment variation (RX & TX)
       
    end
end
cd (pathGUI)


%% WaterAbosrptionCoefficient PLOT  
% Francois and Garrison Formula p. 57 in Hovem
% inputs
% temp = handles.settings.temp;        % temperature
% Salinity = handles.settings.Salinity;        % salinity  
% C = mean(handles.settings.SSP);        % sound speed
% fc = handles.settings.carrierF*1000; % signal frequency
% fc = fc/1000;
% D= handles.class1.depth; % depth
% 
% dist = reshape(handles.class1.dist,1,[]);
% dir = handles.class1.dir;
% maxDist = max(dist);
% Kelvin=temp+273;
% 
% PH=7.8;
% 
% if (temp <=20)
%     A3=4.937e-4-2.59e-5*temp+9.11e-7*temp^2-1.5e-8*temp^3;
% else
%     A3 = 3.964e-4 - 1.146e-5*temp + 1.45e-7*temp^2 - 6.5e-10*temp^3;
% end
% P3=1-3.38e-5*D+D^2*10e-10;
% 
% A2=21.44*Salinity/C*(1+0.025*temp);
% P2=1-1.37e-4*D+6.2e-9*D^2;
% f2=8.17*10^(8-1990/Kelvin)/(1+0.0018*(Salinity-35));
% 
% A1=8.86/C*10^(0.78*PH-5);
% P1=1;
% f1=2.8*(Salinity/35)^0.5*10^(4-1245/Kelvin);
% 
% alpha1=A1*P1*f1*fc.^2./(fc.^2+f1^2);
% alpha2=A2*P2*f2*fc.^2./(fc.^2+f2^2);
% alpha3=A3*P3*fc.^2;
% alpha=alpha1+alpha2+alpha3;
% A1=8.86/C*10^(0.78*PH-5);
% P1=1;
% f1=2.8*(Salinity/35)^0.5*10^(4-1245/Kelvin);
% f = 11:1000:1000000;
% f = f./1000;
% alpha1=A1*P1*f1*f.^2./(f.^2+f1^2);
% alpha2=A2*P2*f2*f.^2./(f.^2+f2^2);
% alpha3=A3*P3*f.^2;
% alpha=alpha1+alpha2+alpha3;
% figure
% loglog(f,alpha);
% hold on
% alpha1=A1*P1*f1*fc.^2./(fc.^2+f1^2);
% alpha2=A2*P2*f2*fc.^2./(fc.^2+f2^2);
% alpha3=A3*P3*fc.^2;
% alphaFc=alpha1+alpha2+alpha3;
% plot(fc,alphaFc,'s',...
%     'LineWidth',2,...
%     'MarkerSize',6,...
%     'MarkerEdgeColor','r',...
%     'MarkerFaceColor',[0.5,0.5,0.5])
% xlabel('Frequency - kHz')
% ylabel('Attenuation - dB/km')
% title('Water Absorption')
% grid on 
% hold off

% %% Ambient Noise 
% 
% Fs = handles.settings.Fs; 
% Fsize= handles.settings.samplesPerFrame;
% sS= handles.settings.seastate; 
% nCh= 1;
% noiseLength = ceil(maxDist/C*fs);
% if noiseLength < fs
%     % create normally distributed noise.
%     wn = randn(1,fs+fSize);
%     % create noise with 17 dB decrease in power per octave. 
%     amn = ambientHighFreq(fs+fSize);
% else
%     % create normally distributed noise.
%     wn = randn(1,noiseLength+fSize);
%     % create noise with 17 dB decrease in power per octave. 
%     amn = ambientHighFreq(noiseLength+fSize);
% end
% 
% % normalization
% wn = wn - mean(wn);
% wn = wn./(max(abs(wn)));
% 
% amn = amn - mean(amn);
% amn = amn./max(abs(amn));
% 
% 
% 
% 
% fstop = 700;
% fstart = 1200;
% % lowpass and highpass filter signal to create ambient noise according to
% % figure in marine acoustics book (Hovem)
% [hpF,lpF] = designFilter(fs,fstop,fstart);
% wn = filter(lpF.Coefficients,1,wn);
% amn = filter(hpF.Coefficients,1,amn);
% 
% % add the two sort of noises to create a single noise array.
% noi = wn+amn;
% % noise per 1muPa
% noi = noi./(10^-6);
% 
% % create power spectral density of noise signal
% nfft = 2^nextpow2(fs);
% AmbientN = fft(noi,nfft);
% AmbientN = AmbientN(1:nfft/2+1);
% AmbientNW = (1/(fs*nfft)).*abs(AmbientN).^2;
% AmbientNW(2:end-1) = 2*AmbientNW(2:end-1);
% freq = 0:fs/nfft:fs/2;
% 
% % Noise level power per frequency relative to 1 muPa 
% ANL = 10*log10(AmbientNW);
% % Mean noise level for up to 1000 Hz.
% meanANL =mean(ANL(100:1000));
% 
% % add noise gain according to figure 11.8 in hovem with correction
% correction = meanANL - 50;
% NOISE = 20*log10(noi)-correction + 4*(sS-1);
% noi = 10.^(NOISE./20);
% % pick out noise with one frame of length
% noise = real(noi);
% 
% ANL = ANL - correction + 4*(sS-1);
% figure
% semilogx(freq,smooth(ANL,10)); grid on;
% title('Ambient noise, sea state');
% xlabel('Frequency (Hz)'); ylabel('Power/Frequency (dB/Hz)');
% xlim([100 fs/2])
% ylim([0 100])














% 
% %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Plotting the channel parameters:  
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set_channel_params_changed
% %% Plot the Doppler rates: 
% 
% % drifting:
% figure; subplot(411); plot(t_tot_vec, (1/c)*Dopp_mat(:,1).*cos(Dopp_mat(:,2))); 
% ylabel('TX drifting'), set(gca,'XTick', (0:T_SS:T_tot)), 
% title('Doppler rates relative to horizontal')
% subplot(412); plot(t_tot_vec, (1/c)*Dopp_mat(:,3).*cos(Dopp_mat(:,4))); 
% ylabel('RX drifting'), set(gca,'XTick', (0:T_SS:T_tot)),
% 
% % vehicular:
% subplot(413); plot(t_tot_vec, (1/c)*Dopp_mat(:,5).*cos(Dopp_mat(:,6))); 
% ylabel('TX vehicular'), set(gca,'XTick', (0:T_SS:T_tot)), 
% subplot(414); plot(t_tot_vec, (1/c)*Dopp_mat(:,7).*cos(Dopp_mat(:,8))); 
% ylabel('RX vehicular'), set(gca,'XTick', (0:T_SS:T_tot)),
% xlabel('time [s]')
% 
% %% Plot the nominal channel geometry: 
% 
% figure; 
% plot([0,0], [0,ht0], 'r'), hold on,
% plot(0,ht0, 'rx', 'linewidth', 2, 'markersize', 10), 
% plot([d0,d0], [0,hr0], 'r'), 
% plot(d0,hr0, 'rx', 'linewidth', 2, 'markersize', 10),
% plot([-.1*d0, 1.1*d0], [0, 0], 'k', 'linewidth', 2),
% plot([-.1*d0, 1.1*d0], [h0,h0], 'b', 'linewidth', 2),
% 
% axis([-.1*d0, 1.1*d0, -.1*h0, 1.1*h0]),
% xlabel('range [m]'), ylabel('height above bottom [m]'),
% text(.02*d0, ht0, 'TX'), text(1.02*d0, hr0, 'RX'), 
% title('Nominal channel geometry')
% 
% 
% 
