%% time and doppler spread
function [ranges,index] = rangesDopplerSpread(Narr,SrcAngle,RcvrAngle,...
    NumTopBnc,NumBotBnc,txPos,rxPos,depth)
% index{nChannels} = 0;
% r{nChannels} = 0;
% for n = 1:nChannels
n = 1;
    tempNarr = Narr;
    tempScrAng = SrcAngle;
    signScr = sign(tempScrAng);
    tempRcvrAng = RcvrAngle;
    signRcvr = sign(tempRcvrAng);
    teller = 0;
    index = zeros(tempNarr,1);
    r = zeros(1,4);
    for m = 1:tempNarr
        if NumTopBnc(m)~=0
            tempRcvrAng(m) = signRcvr(m)*tempRcvrAng(m)/180*pi;
            tempScrAng(m) = signScr(m)*tempScrAng(m)/180*pi;
            teller = teller+1;
            index(teller) = m;
            % One surface reflection
            if ( (NumTopBnc(m) == 1) && (NumBotBnc(m)==0) )
                r1 =      txPos/sin(tempScrAng(m));
                r2 = rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,0,0];
            % Bottom refletion first, surface reflection second
            elseif ( (NumTopBnc(m) == 1) && (NumBotBnc(m)==1) ...
                    && (signScr(m)==-1) )
                r1 =      depth/sin(tempRcvrAng(m))+...
                    txPos/sin(tempScrAng(m));
                r2 = rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,0,0];
            % Surface reflection first, bottom reflection second
            elseif ( (NumTopBnc(m) == 1) && (NumBotBnc(m) == 1) ...
                    && (signScr(m) == 1) )
                r1 = txPos/sin(tempScrAng(m));
                r2 = depth/sin(tempScrAng(m))+...
                    rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,0,0];
            % One surface reflection and two bottom reflections
            elseif ( NumTopBnc(m) == 1 )
                r1 = depth/sin(tempScrAng(m))+...
                    txPos/sin(tempScrAng(m));
                r2 = depth/sin(tempRcvrAng(m))+...
                    rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,0,0];
            % Two surface reflections, and one bottom reflection
            elseif (signScr(m)==signRcvr(m) && (NumTopBnc(m)==2) ...
                    && (NumBotBnc(m)==1) )
                r1 = txPos/sin(tempScrAng(m));
                r2 = depth/sin(tempScrAng(m));
                r3 = depth/sin(tempRcvrAng(m));
                r4 = rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,r3,r4];
            % Two bottom and surface reflections, surface first    
            elseif ( (signScr(m) == 1) && (NumTopBnc(m)==2) ...
                    && (NumTopBnc(m)==2) )
                r1 = txPos/sin(tempScrAng(m));
                r2 = depth/sin(tempScrAng(m));
                r3 = depth/sin(tempRcvrAng(m));
                r4 = depth/sin(tempRcvrAng(m)) +... 
                    rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,r3,r4];
            % Two bottom and surface reflections, bottom first
            elseif ( (signScr(m) == -1) && (NumTopBnc(m)==2) ...
                    && (NumTopBnc(m)==2) )
                r1 = txPos/sin(tempScrAng(m))...
                    + depth/sin(tempScrAng(m));
                r2 = depth/sin(tempScrAng(m));
                r3 = depth/sin(tempRcvrAng(m));
                r4 = rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,r3,r4];
            % All others
            else
                r1 = depth/sin(tempScrAng(m))*(NumTopBnc(m)-2)+...
                    txPos/sin(tempScrAng(m));
                r2 = depth/sin(tempScrAng(m))*(NumTopBnc(m)-1);
                r3 = depth/sin(tempRcvrAng(m))*(NumTopBnc(m)-1);
                r4 = depth/sin(tempRcvrAng(m))*(NumTopBnc(m)-2)+...
                    rxPos/sin(tempRcvrAng(m));
                r(teller,1:4) = [r1,r2,r3,r4];
            end
        end
    end
% end
ranges = r;