% script for loading data to test functions
clear all
close all
clc
start = tic;
fs = 96000; % sampling rate
% U = 2; % wind speedx
SrcAngle{1}  = [15,25,-35,40,45,70]; % source angle
RcvrAngle{1} = [15,25,-35,40,-45,70]; % receiver angle
NumTopBnc{1} = [0,0,1,0,2,6];
NumBotBnc{1} = [0,1,2,1,2,7];
txPos = 30; % TX position vertical
rxPos = [10,20];
nChannels = 1;
depth = 50;
Narr{1} = length(NumBotBnc{1}); % number of paths
c = 1500; % sound speed
fc = 21;
BW = 8000;
frameSize = 1536;
delay{1} = [0.1,0.2,0.3,0.4,0.5,0.6];

amp{1}=[1,1,1,1,1,1];%linspace(20,1,6);

temp = 10;
% seastate = handles.settings.seastate;
% waveHeight = handles.settings.waveHeight;
seastate = 1;
waveHeight = [0 0.1 0.1+0.4*rand(1) 0.5+0.75*rand(1) 1.25+1.25*rand(1)...
    2.5+1.5*rand(1)  4+2*rand(1) 6+3*rand(1) 9+5*rand(1) 14+2*rand(1)];

doppMat{nChannels} = 0;
index{nChannels} = 0;
for n = 1:nChannels % Multipath channels
    waveMax = [0, 0.1, 0.5, 1.25, 2.5, 4, 6, 9, 14, 18];
    U = [0 1.5 3.3 5.4 7.9 10.7 24.4 28.4 32.6 32.6*18/14];
    U = U.*waveHeight./waveMax;
    [r,index{n}] = rangesDopplerSpread(Narr{n},SrcAngle{n},RcvrAngle{n},...
    NumTopBnc{n},NumBotBnc{n},txPos,rxPos(n,:),depth);
    [doppMat{n}] = dopplerSpread(fs,U(seastate+1),r,c,fc,SrcAngle{n},RcvrAngle{n},BW, frameSize);
end


% find the maximum number of samples in the scatter matrix
maxDopp = 0;
for n = 1:nChannels
    tempNarr = length(doppMat{n});
    for m = 1:tempNarr
        [upDate,tempMax] = size(doppMat{n}{m});
        if tempMax>maxDopp
            maxDopp = tempMax;
        end
    end
end


% Finner max delay av alle refleksjoner for alle multipath kanalene
maxDelay = 0;
for n = 1:nChannels
    tempNarr = Narr{n};
    tempDelay = delay{n};
    tempMaxDelay = max(tempDelay(1:tempNarr));
    
    if (maxDelay<tempMaxDelay)
        maxDelay = tempMaxDelay;
    end
end





% Number of coefficients in water absorption filter
nCoef = 31;

% samples of maximum delay - system delay
samples = round(maxDelay*fs);

samples = samples+nCoef+maxDopp;

% create an array to convolve the input signal with to add delay
b = zeros(samples,upDate,nChannels);






tete = [];
for m = 1:nChannels % multipaths
    tempDelay = delay{m};
    tempAmp = amp{m};
    teller = 1;
    for n = 1:Narr{m} % reflections
%         tempDop = doppMat{m}{n};
        coef = designAbsorptionFilter(tempDelay(n)*c,fs,temp,c,depth);
        inToB = coef;
        leng = length(inToB)-1;
        if ( index{m}(teller) == n )
            tempDop = doppMat{m}{teller};
            teller = teller+1;
            for i = 1:upDate
            
%             for i = 1:upDate
                inToB = conv(coef,tempDop(i,:));
                
                
                if teller > length(index{m})
                    teller = length(index{m});
                end
                leng = length(inToB)-1;

                a = round(tempDelay(n)*fs);
                b(a:a+leng,i,m) = b(a:a+leng,i,m) + ...
                    (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
            end
        else
            for i = 1:upDate
                a = round(tempDelay(n)*fs);
                b(a:a+leng,i,m) = b(a:a+leng,i,m) + ...
                    (abs(tempAmp(n))*sign(real(tempAmp(n))).*inToB)';
            end
        end
        
    %     coefs(n,:) = coef;
        
        
    end
end
figure
for t = 1:teller;
    subplot(6,1,t) 
    plot(doppMat{1}{t}(10,:))
end
figure; plot(b(10000,:,1))
figure
plot(b(:,1,1))
toc(start)