function writeBellhopInput()

% LOAD BATHYMETRY AND CONVERT TO BELLHOP-READABLE FORMAT
% OUTPUT in '.bty' file

% [filnambty,pathnambty] = uigetfile('.mat','Choose Bathymetry file');
% filout = [filnambty(end-6:end-4) '.bty'];
% load([pathnambty filnambty])
% load('Bathymetry_ST2.mat');
% 
% figure;subplot(1,4,[2 4]);
% plot(DepthProfile(:,1),DepthProfile(:,2));hold on; %#ok<NODEF>
% 
% Lbt = length(DepthProfile(:,1));
% % Downsample bathymetry
% rang = DepthProfile(1:10:Lbt,1);
% bath = DepthProfile(1:10:Lbt,2);
% plot(rang,bath,'r');
% set(gca,'YDir','reverse');
% legend('Original bathymetry','Downsampled bathymetry')
% 
% filout = 'ST2.bty'
% fid = fopen(filout,'w');
% frewind(fid);
% fprintf(fid,'''L''\n');
% fprintf(fid,'%d\n',length(rang));
% 
% for i = 1:1:length(rang)
%     fprintf(fid,'%8.2f %8.2f \n',[rang(i)*1e-3 bath(i)]);
% end
% fclose(fid);
% copyfile(filout,[filout(1:3) 'ray' filout(4:end)])
% copyfile(filout,[filout(1:3) 'eig' filout(4:end)])
% copyfile(filout,[filout(1:3) 'arr' filout(4:end)])
%
% READ SSP form '.cnv' files
% Keep upcast SSP and output in tmp.ssp
% in Bellhop-readable format
%
%bath = 401.256;



global pathGUI returnTrue
acpath = cd;
cd('CTD');
[filnam,pathnam] = uigetfile('*.*','Load Speed Profile');
if isequal(filnam,0)
    disp('cancel')
    DEP_u=0;
    SSPwm_u=0;
    returnTrue=1;
    cd(pathGUI)
    
    return
end

filnam = [pathnam filnam];


cd(acpath);

check = filnam(end-3:end);
if check == '.cnv'
    [DEP_u, SSPwm_u] = readcnv(filnam);
    global sspu_ds depu_ds
    if returnTrue==1
        return
    end
    bath = max(DEP_u);
    Lsp = length(DEP_u);
    % Downsample SSP
    nds = 1;
    while abs(DEP_u(100)-DEP_u(([100+nds ]))) < 5
        nds = nds + 1;
        if (100+nds>Lsp),
            break;
        end;
    end
    depu_ds = DEP_u(1:nds:Lsp);
    sspu_ds = SSPwm_u(1:nds:Lsp);
    %disp(depu_ds)
    % Add 0-depth and max-depth SSP
    Lsp = length(depu_ds);
    slop = (sspu_ds(Lsp) - sspu_ds(Lsp-1))/(depu_ds(Lsp)-depu_ds(Lsp-1));
    if slop < 0, slop = abs(slop);end
    sspmxb = slop*(max(bath) - depu_ds(Lsp)) + sspu_ds(Lsp); % Extrapolate max depth ssp
    % 
    depu_ds = [0;       depu_ds;   max(bath)];
    sspu_ds = [sspu_ds(1); sspu_ds;   sspmxb];
    % 
    Lsp = Lsp + 2;
    fid = fopen('tmpssp.txt','w');
    frewind(fid);
    for i = 1:1:Lsp
        fprintf(fid,'%10.2f %10.2f \n',[depu_ds(i) sspu_ds(i)]);
    end
    fclose(fid);
    %
    % figure;
    %subplot(1,4,1);
    %plot(SSPwm_d,DEP_d,'k');hold on
    % plot(sspu_ds,depu_ds)
    % axis ij
    % axis tight
    % title('Sound-Speed Profile')

    disp('*** OUTPUT in tmpssp.txt file ***')
    % open('tmpssp.txt')
    disp('*** COPY/PASTE Output into Bellhop Input file (*.env) ***')
elseif check == '.txt'
    [DEP_u, SSPwm_u] = readTXT(filnam);
%         global sspu_ds depu_ds
    if returnTrue==1
        return
    end
    bath = max(DEP_u);
    Lsp = length(DEP_u);
    
    deciFac = ceil(Lsp/100);
    
    DEP_u = decimate(DEP_u,deciFac);
    SSPwm_u = decimate(SSPwm_u,deciFac);
    
    DEP_u = [DEP_u(1);DEP_u;];
    SSPwm_u = [0; SSPwm_u];
    
    
    bath = max(DEP_u);
    Lsp = length(DEP_u);
    
    
    fid = fopen('tmpssp.txt','w');
    frewind(fid);
    for i = 1:1:Lsp
        fprintf(fid,'%10.2f %10.2f \n',[SSPwm_u(i) DEP_u(i)]);
    end
    fclose(fid);

    disp('*** OUTPUT in tmpssp.txt file ***')
    % open('tmpssp.txt')
    disp('*** COPY/PASTE Output into Bellhop Input file (*.env) ***')
else
    disp('Must be a .txt or .cnv file')
    DEP_u=0;
    SSPwm_u=0;
    returnTrue=1;
    cd(pathGUI)
    
    return
end
end
    
%-----------------------------------------
%-----------------------------------------
function [DEP_u, SSPwm_u] = readcnv(filnam)
% global pathGUI pathFunc returnTrue
% acpath = cd;
% cd('CTD');
% [filnam,pathnam] = uigetfile('.cnv','Choose CTD file');
% if isequal(filnam,0)
%     disp('cancel')
%     DEP_u=0;
%     SSPwm_u=0;
%     returnTrue=1;
%     cd(pathGUI)
%     
%     return
% end
% 
% filnam = [pathnam filnam];
% 
% cd(acpath);


fid = fopen(filnam,'r');
frewind(fid);

for i=1:9
    fgetl(fid);
end

% Real-time sampling interval
Ts = fscanf(fid,'* Real-Time Sample Interval = %f seconds',1)
fgetl(fid);

% Number of represented quantities
Nprm = fscanf(fid,'# nquan = %d',1)
fgetl(fid);

% Number of measured parameter values
Npvl = fscanf(fid,'# nvalues = %d',1)
fgetl(fid);
fgetl(fid);

% Parameter names
tmp = [];
while ~strcmp(tmp,'*END*')
    tmp=fgetl(fid);
end

data = zeros(Nprm, Npvl);
data = fscanf(fid, ['%d' repmat('%f ',1,Nprm-1)],[Nprm Npvl]);
data = data.';

% Separate down and up measurements
[~, idxdn] = max(data(:,2));
idxup = idxdn;

% Retrieve data into separate vectors
idcnt_d    = data(1:idxdn,1);
DEP_d      = data(1:idxdn,2);
COND_d     = data(1:idxdn,3);
TEMP_d     = data(1:idxdn,4);
SAL_d      = data(1:idxdn,5);
SSPcm_d    = data(1:idxdn,6);
PRES_d     = data(1:idxdn,7);
DENS_d     = data(1:idxdn,8);
DESCrate_d = data(1:idxdn,9);
SSPdm_d    = data(1:idxdn,10);
SSPwm_d    = data(1:idxdn,11);
flag_d     = data(1:idxdn,12);

idcnt_u    = flipud(data(idxdn:Npvl,1));
DEP_u      = flipud(data(idxdn:Npvl,2));
COND_u     = flipud(data(idxdn:Npvl,3));
TEMP_u     = flipud(data(idxdn:Npvl,4));
SAL_u      = flipud(data(idxdn:Npvl,5));
SSPcm_u    = flipud(data(idxdn:Npvl,6));
PRES_u     = flipud(data(idxdn:Npvl,7));
DENS_u     = flipud(data(idxdn:Npvl,8));
DESCrate_u = flipud(data(idxdn:Npvl,9));
SSPdm_u    = flipud(data(idxdn:Npvl,10));
SSPwm_u    = flipud(data(idxdn:Npvl,11));
flag_u     = flipud(data(idxdn:Npvl,12));

fclose(fid);
%disp(DEP_u)
idx = find(DEP_u < 2,1,'last');
DEP_u = squeeze(DEP_u(idx+1:end));
SSPwm_u = squeeze(SSPwm_u(idx+1:end));
end