function varargout = ChannelSimulator(varargin)
% 
% CHANNELSIMULATOR MATLAB code for ChannelSimulator.fig
%      CHANNELSIMULATOR, by itself, creates a new CHANNELSIMULATOR or raises the existing
%      singleton*.
%
%      H = CHANNELSIMULATOR returns the handle to a new CHANNELSIMULATOR or the handle to
%      the existing singleton*.
%
%      CHANNELSIMULATOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CHANNELSIMULATOR.M with the given input arguments.
%
%      CHANNELSIMULATOR('Property','Value',...) creates a new CHANNELSIMULATOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ChannelSimulator_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ChannelSimulator_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the rdmsesponse to help ChannelSimulator

% Last Modified by GUIDE v2.5 06-May-2015 09:08:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ChannelSimulator_OpeningFcn, ...
                   'gui_OutputFcn',  @ChannelSimulator_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ChannelSimulator is made visible.
function ChannelSimulator_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ChannelSimulator (see VARARGIN)

% Choose default command line output for ChannelSimulator
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ChannelSimulator wait for user response (see UIRESUME)
% uiwait(handles.figure1);
initialize_gui(hObject, handles, false);

% --- Outputs from this function are returned to the command line.
function varargout = ChannelSimulator_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%% INITIALIZE THE GUI %%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function initialize_gui(hObject, handles, isreset)
% If the class1 field is present and the reset flag is false, it means
% we are we are just re-initializing a GUI by calling it from the cmd line
% while it is up. So, bail out as we dont want to reset the data.
global pathGUI pathFunc minDist filnam samplesDelay ms SamplesPerFrame ...
HorizontalRx
filnam = 'default';
pathGUI=cd;
cd ..
cd Functions
pathFunc = cd;
cd (pathGUI)
% Default values based on calibration.
minDist = [56.8000000000000 56.8000000000000 73.2300000000000 138.940000000000 204.640000000000 270.350000000000 401.760000000000 533.180000000000 1058.83000000000 2110.14000000000];
SamplesPerFrame = [1024 1536 2048 4096 6144 8192 12288 16384 32768 65536];
samplesDelay = [3540 3540 4564 8660 12756 16852 25044 33236 66004 131540];
ms = [36.8900000000000 36.8900000000000 47.5500000000000 90.2200000000000 132.890000000000 175.550000000000 260.890000000000 346.220000000000 687.550000000000 1370.22000000000];

axes(handles.axes1);

%if isfield(handles, 'class1') && ~isreset
%    return;
%end

% JPG FIGURE (START FIGURE)
rgb = imread('FrontPageGui.jpg');
image(rgb)
% % title('RGB image')
set(gca,'YTickLabel',[])
set(gca,'XTickLabel',[])
axes(handles.axes1);
hold off 
% 
axes(handles.axes2);
rgb = imread('cnode.jpg');
image(rgb)
% % title('RGB image')
set(gca,'YTickLabel',[])
set(gca,'XTickLabel',[])
hold off 
% 
axes(handles.axes1);


% set(handles.output, 'HandleVisibility', 'off');
% set(handles.axes1, 'HandleVisibility', 'off');
% set(handles.axes2, 'HandleVisibility', 'off');

% close all;
% set(handleToYourMainGUI, 'HandleVisibility', 'on');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd (pathFunc)
%Loading a default file, which has been processed before. 
handles.settings.filenameArr='MakedFile\default.arr';
handles.settings.filenameSoundSpeed= 'MakedFile\defaultSoundSpeed.txt';
handles.settings.filenameRay= 'MakedFile\default.ray';
[ Arr, Pos ] = read_arrivals_asc(handles.settings.filenameArr);
handles.settings.Arr{1} = Arr;
% change to  handles.settings.nArrival!! 
handles.settings.Pos = Pos;
fid = fopen(handles.settings.filenameRay,'r');
TITLE  = fgetl(  fid );
FREQ   = fscanf( fid, '%f', 1 );
NBEAMS = fscanf( fid, '%i', 1 );
DEPTHT = fscanf( fid, '%f', 1 );
handles.class1.depth = fscanf( fid, '%f', 1 );

[handles.settings.SSP, handles.settings.SSP_z]=readSpeedAndDepth(handles.settings.filenameSoundSpeed);
cd (pathGUI)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %%%%%%%%%% default values %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles.class1.vertical = Pos.r.depth;
handles.class1.horizontal = Pos.r.range;

% CHANGE NAME TO: nodesDistance2D
% handles.class1.Rx2D(1)=handles.class1.horizontal; %X 
% handles.class1.Rx2D(2)=handles.class1.vertical; %Z 

handles.class1.nodesDistance2D(1,2)=handles.class1.horizontal; %X

handles.class1.VerticalTx = Pos.s.depth;         % vertical dist. Tx

% DELETE AFTER 3D implementation is done
% handles.class1.Rx(1,1) = handles.class1.horizontal; %X        % horizontal dist. Rx
% handles.class1.Rx(1,2) = 0; % Y
% handles.class1.Rx(1,3) = handles.class1.vertical; %Z           % vertical dist. Rx 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

handles.class1.nodesPosition(1,1) = 0;
handles.class1.nodesPosition(1,2) = 0;
handles.class1.nodesPosition(1,3) = handles.class1.VerticalTx;

handles.class1.nodesPosition(2,1) = handles.class1.horizontal;
handles.class1.nodesPosition(2,2) = 0;
handles.class1.nodesPosition(2,3) = handles.class1.vertical;

% Channel nodes, default h1. 
handles.class1.nodesChannel(1,1)=0; % Horizontal TX
handles.class1.nodesChannel(1,2)= handles.class1.VerticalTx; % Vertical TX
handles.class1.nodesChannel(1,3)=handles.class1.horizontal; % Real distance RX
handles.class1.nodesChannel(1,4)=handles.class1.vertical; % Vertical RX
handles.class1.nodesChannel(1,5)=0; % Y-direction RX
handles.class1.nodesChannel(1,6)=1500; % Horizontal Position between RX & TX 
handles.class1.nodesChannel(1,7)=0; % Y-direction TX
handles.class1.nodesChannel(1,8)=1500; % Actual Horizontal Distance to RX

handles.class1.nChannel =1; % default 1 channel (point-to-point) 
HorizontalRx = max(handles.class1.nodesPosition(:,1));

handles.class1.networkTree(1,2)=2; % point-to-point 

handles.settings.cBottom1=1600; % m/s, soundspeed layer 1
handles.settings.csBottom1=0; % m/s, shear wave speed, layer 1   
handles.settings.alphaBottom1=[10,1];%dB/m, alpha attenuation, layer 1
handles.settings.densBottom1=2.8; %g/cm3, density, layer 1
handles.settings.temp=10; %Celcius, degrees at bottom
handles.settings.Salinity=35; %ppt, salinity in sea. 
handles.settings.seastate=0;
handles.settings.seabed=0;
handles.settings.heightSeabedChange=20; % [m] Seabed creation 

handles.settings.waveHeight = [0 0.1 0.1+0.4*rand(1) 0.5+0.75*rand(1) 1.25+1.25*rand(1)...
    2.5+1.5*rand(1)  4+2*rand(1) 6+3*rand(1) 9+5*rand(1) 14+2*rand(1)];
handles.settings.nodes=2; 
% add the Rx values into a vector
handles.t.transAng=0;                     % 0 degrees at the Transducer 
handles.settings.propagationDelay=0; 

% default value for the soundcard 
handles.settings.Fs=96000;                   % Sampling Frequency 
handles.settings.soundcard= 'default';        % Soundcard, 
% with problems check in MATLAB : "home" -> "preferences" -> "DSP toolbox" 
% -> check (ASIO) 
handles.settings.numbOfInOut=2;              % Number of channels
handles.settings.samplesPerFrame=1536;      % default samplesPerFrame

handles.settings.Bandwidth=8000;         % Bandwidth in Hz
handles.settings.dms=0.051;             % seconds delay in processing
% ms=0.051; 
handles.settings.carrierF= 21;          % Carrier freq. in kHz  


% default values for transducer
handles.t.transmitterSens = 154.8;      % dB, transmitter strength
handles.t.receiverSens = -190;          % dB, receiver strength.
handles.t.TransducerGain = 0;           

% BELLHOP default number of reflections : 0 
handles.class1.numberOfReflections=0;
% ENV FILE Default INPUT
handles.settings.EnvOpt1='SVF *';
handles.settings.EnvOpt2='A';
handles.settings.EnvOpt3='A';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% True false, statements
global reflections ChangedValue intensityTrue BellhopTrue ...
    forever depth returnTrue
reflections = 0; 
ChangedValue=0;
intensityTrue=0;
BellhopTrue=0;
forever = 0;
returnTrue=0;
depth=handles.class1.depth;
handles.statement.firstTime=1;
handles.statement.RecordData=1;
handles.statement.DopplerSpread=1;
handles.statement.absorption=1;
handles.settings.attenuationSea= 1;
handles.statement.propTrue=1;
handles.statement.loadTrans=0;                
handles.statement.loadTransSens=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%set the statements at the GUI
set(handles.verticalRx, 'String', handles.class1.nodesPosition(2,3));
set(handles.horizontalRx,  'String', handles.class1.nodesPosition(2,1));
set(handles.depth,  'String', handles.class1.depth);
set(handles.verticalTx,  'String', handles.class1.VerticalTx);
set(handles.transducerAngle, 'String', handles.t.transAng);
set(handles.temperature,'String', handles.settings.temp);
set(handles.salinity, 'String', handles.settings.Salinity);

str  = [num2str(handles.settings.densBottom1) ' g/cm^3'];
str2 = [num2str(handles.settings.cBottom1), ' m/s'];
set(handles.SeabedDensity, 'String', str);
set(handles.SeabedSpeed, 'String', str2);
set(handles.WindSpeed, 'String', '<0.3 m/s')
% POP-UP MENU DEFAULT
set(handles.samplingFreq, 'Value', 3);
set(handles.chooseSoundCard, 'Value', 1); % 1= default, 2=UA-25, 3 = OCTA-CAPTURE
set(handles.attenuationSea,'Value',1);
set(handles.DopplerSpread,'Value',1);
% Change color for START/STOP
set(handles.Realtime,'String','START');
set(handles.Realtime,'BackgroundColor',[0.639 0.91 0.651]);

set(handles.TransducerSensDisp, 'String',  [num2str(handles.t.transmitterSens) ' [dB/V ]']);
set(handles.ReceiverSensDisp, 'String', [num2str(handles.t.receiverSens) ' [V/dB]']);
set(handles.MinDist, 'String', num2str(min(minDist)));

% Features Statement    
set(handles.delayPropagation, 'Value',1);
set(handles.Multipaths, 'Value',1);
set(handles.DopplerSpread, 'Value',1);
set(handles.attenuationSea, 'Value',1);
set(handles.RecordData, 'Value',1);

cd (pathFunc)
handles.settings.noise = ambientNoise(handles);
cd (pathGUI)

% Ouput handles.
assignin('base','handles',handles)
guidata(hObject,handles)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in loadTransducerdata.
function loadTransducerdata_Callback(hObject, eventdata, handles)
% hObject    handle to loadTransducerdata (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global pathGUI pathFunc
cd TransducerData 
[filename, path] = uigetfile('.txt', 'Transducer');
FID = fopen('TransducerFreq.txt', 'r');
cd(pathGUI)
if isequal(filename,0)
    disp('cancel')
    return
end
cd (pathFunc)

% make a string of the choosen file. 
handles.t.filename=filename;
filenamePath=strcat(path,filename); 
transducerData=read_txt(filenamePath);
handles.t.transducerData=transducerData;
% open file with transducer freq. names 
%         eval(['NAME_' num2str(i) '=dataset;']);

while ~feof(FID) % s lenge filen ikke er avsluttet
    line = fgetl(FID); % f frste linje
    separate=find(line==';');
    for i=1:length(separate)+1
        [freq, line] = strtok(line, ';');
        handles.t.freq_name{i}=strtrim(freq);
    end
end
fclose(FID);     
% Make a dataset for the different datasettings from the transducer. 
if (strcmp(filename, 'directivityTransducer.txt'))
    directivityData=transducerData;
    [row,col]=size(directivityData);
    theta=linspace(-130,130,row*2-1);
    name=[];
    color=['r','b','g','bl','y','t','c'];
    figure
    for i=1:col-1
        a = mod(i,length(color));
        if a ==0
            a = length(color);
        end
        transducer=directivityData(:,i+1)';
        % to get the whole spectra from -90 to +90 degrees
        transducer=[fliplr(transducer(1:end)), transducer(2:end)];
        eval(['handles.t.transducer' handles.t.freq_name{i} '=transducer;']);
        p{i}=polardb(theta,transducer,-30,3,color(i));
        hold on
        name=[name, ' ',handles.t.freq_name{i}];
        title('Beam pattern to the transducer')
        grid on
        handles.statement.loadTrans=1;
    end

    name=strsplit(name(2:end));
    legend([p{1:length(p)}],name )
    hold off
end
if (strcmp(filename, 'sensitivityTransducer.txt'))
    handles.t.sensitivtyData=transducerData;
    handles.statement.loadTransSens=1;
end
FreqName=[num2str(handles.settings.carrierF) 'kHz'];
disp(FreqName)
handles.t.transducerCarrierFreq=eval(['handles.t.transducer' FreqName]);
% Seperate out the different different frequencies.
% for i=1:length(handles.t.freq_name)-1
%     transducer{i}=eval(['handles.t.transducer' handles.t.freq_name{i}]);
% end

assignin('base','handles',handles)
guidata(hObject, handles);

cd (pathGUI)

% --- Executes on button press in Realtime.
function Realtime_Callback(hObject, eventdata, handles)
% hObject    handle to Realtime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global pathGUI pathFunc 
cd (pathFunc)


RealTime(handles);

cd (pathGUI)



% --- Executes on button press in initialize.
function initialize_Callback(hObject, eventdata, handles)
% hObject    handle to initialize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%  INITIALIZE AFTER CHANGE IN SETTINGS  %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global pathGUI pathFunc filename filnam ChangedValue intensityTrue pathnam ...
    sspu_ds depu_ds BellhopTrue outputMenu2 HorizontalRx depth ...
    nSampl samplesDelay minDist peaksDetected ms SamplesPerFrame


%Rx=handles.class1.Rx;
%x=handles.class1.horizontal;
D=handles.class1.depth; %
% depth=handles.class1.depth;
% HorizontalRx=max(handles.class1.nodesDistance2D(:,2));
N=handles.class1.numberOfReflections;
Tx=handles.class1.VerticalTx;


BellhopTrue =1;
cd(pathFunc)
actpath = cd; 

handles.plot.waitbar=waitbar(0,'Please wait, Loading');

% DOPPLER!! MAKING FILE!! NEED TO BE MORE COOL.
% set_channel_params_changed % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Run Doppler Bellhop
waitbar(1/5)
nodes= handles.settings.nodes;

[nChannel,~]=size(handles.class1.nodesChannel);
handles.class1.nChannel=nChannel;

if ChangedValue~= 0 ||  handles.statement.firstTime ==  0
    ChangedValue=0;
    handles.statement.firstTime=0;
    % edit([filnam filename '.env'])
%   title= inputdlg ('Title on your ENV file :');
    title= newid ('Title on your ENV file :');
    if isequal(title,{})
        disp ('cancel')
        waitbar(5/5)
        close(handles.plot.waitbar)
        return
    end
    title=title{1};
    
%     set(h, 'HandleVisibility', 'on');
    cd MakedFile;
    pathnam = cd;
    cd ..
    %filnam=['MakedFile\' title]; 
    filnam=title;
    filename=[];
    filename = [pathnam '\' title];
    
    HorizontalRxMax=max(handles.class1.nodesPosition(:,1));
    handles.class1.HorizontalRxMax=HorizontalRxMax;
    axes(handles.axes1)
%     set(gca,'zdir','reverse') % IF 3D 
    
    hold off 
    
    handles.settings.title = [title '.env'];
    handles.settings.EnvOpt2='A';
%     handles.settings.EnvOpt3='A';
%      if (handles.settings.seabed>0)
%         handles.settings.seabed=handles.settings.seabed-1;
    handles.class1.HorizontalTx=handles.class1.nodesChannel(1,1);
    handles.class1.RealDistanceRX=handles.class1.nodesChannel(1,3);
        [x,z]=createSeabed(handles.settings.seabed,HorizontalRxMax,depth,handles);
        handles.settings.seabedX=x;
        handles.settings.seabedZ=z;
        handles.settings.EnvOpt2='A*';
%      end 
    waveHeight=createSurface(filnam,handles.settings.seastate,HorizontalRxMax);
    handles.settings.waveHeight=waveHeight;
    num{1} = 0;
    handles.settings.nArrival = num;
    
%     plotbty([filename '.bty'],handles)
   
plotbty2(handles)
    
    
    for i = 1:nChannel
                
        % Read channel information(hx) (TX (horizontal and vertical), RX (horizontal and vertical))
        handles.class1.HorizontalTx=handles.class1.nodesChannel(i,1); % Horizontal TX
        handles.class1.VerticalTx= handles.class1.nodesChannel(i,2); % Vertical TX
        handles.class1.RealDistanceRX= handles.class1.nodesChannel(i,3); % Real distance RX
        handles.class1.VerticalRx = handles.class1.nodesChannel(i,4); % Vertical RX
        handles.class1.Ydirections = handles.class1.nodesChannel(i,5); % Y-direction RX 
        
        handles.class1.HorizontalRX= handles.class1.nodesChannel(i,6); % Horizontal Position between RX and TX
        handles.class1.YTx = handles.class1.nodesChannel(i,7); % Y-direction TX
        handles.class1.ActualHorizontalRX= handles.class1.nodesChannel(i,8);
        % Calculate new seabed for each channel
        % Rx Height
        posSeabedRx=min(find(handles.settings.seabedX*1000>=(handles.class1.HorizontalRX)));
        handles.class1.depthSeabedRx=handles.settings.seabedZ( posSeabedRx);
        
        % Tx Height
        newTxdepth=min(find(handles.settings.seabedX*1000>=(handles.class1.HorizontalTx)));
        handles.class1.newTxdepth=handles.settings.seabedZ(newTxdepth);
        
         handles.settings.heightSeabedChange=abs(handles.class1.depthSeabedRx-handles.class1.newTxdepth);
         % TX-RX range, RX height, TX height
         [~,~]=createSeabed(handles.settings.seabed,handles.class1.ActualHorizontalRX,depth,handles);
        
        %%% DELETE AFTER WORK!! 
%         handles.class1.HorizontalRx=handles.class1.Rx(i,1); % X-2D
%         handles.class1.Ydirections=handles.class1.Rx(i,2); 
%         handles.class1.VerticalRx=handles.class1.Rx(i,3); % Z
        %%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        waitbar(1/5)
        
        handles.settings.EnvOpt3='A';
        writeEnvFiles(handles) % Returns to (MakedFile)
        cd (pathFunc)
        disp('***   Running Bellop   ***')
        eval( [ '!' actpath '\bellhop.exe ' 'MakedFile\' filnam] )
        disp('***        Done        ***')
    %     handles.settings.title = [title '.env'];
        waitbar(2/5)
        handles.settings.EnvOpt3='E';
        writeEnvFiles(handles)
        cd (pathFunc)
        eval( [ '!' actpath '\bellhop.exe ' 'MakedFile\' filnam] )
        disp('***        Done        ***')
        disp('--------------------------')
        waitbar(3/5)
        
        handles.settings.filenameArr=['MakedFile\' filnam '.arr'];
        % handles.settings.filenameSoundSpeed= 'MakedFile\defaultSoundSpeed.txt';
        handles.settings.filenameRay= ['MakedFile\' filnam '.ray'];
        [ Arr, Pos ] = read_arrivals_asc(handles.settings.filenameArr);
        handles.settings.nArrival{i} = Arr;
        handles.settings.Pos = Pos;
   
   
   
%     if exist([filename '.ray'],'file')
        fid = fopen(handles.settings.filenameRay,'r');
        TITLE  = fgetl(fid);
        FREQ   = fscanf( fid, '%f', 1 );
        NBEAMS = fscanf( fid, '%i', 1 );
        DEPTHT = fscanf( fid, '%f', 1 );
        handles.class1.depth = fscanf( fid, '%f', 1 );
        
    
%     filename=[filename filnam]; % creates a location with specific name. 
        axes(handles.axes1);



%%%%%%%%%%%%%%%%%%%%%%%% FIGURE ANALYZE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%% ANALYZE THE RAYTRACING FIGURE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        
        disp('*** Plotting Rays or EigenRays ***')
%         hold off 
%         uip = uipanel('Position',[0.75 0.75 0.25 0.25]);
%         subplot(1,5,2:5)
        plotray( [filename '.ray'],handles );
%         plotati( [filename '.ati']);
         plotati2(handles)
%         if (handles.settings.seabed>0)
%             plotbty([filename '.bty'],handles)
%         end
        
     xlim([0,max(handles.class1.nodesPosition(:,1))+50]);
     ylim([-1-max(abs(handles.class1.nodesPosition(:,2))), +1+max(abs(handles.class1.nodesPosition(:,2)))]);
    zlim([0,handles.class1.depth]);
    end
       for j=1:handles.settings.numbOfInOut % LABEL RX AND TX AT THE MAIN ANALYZE
        hold on
        X=handles.class1.nodesPosition(j,1);
        Y=handles.class1.nodesPosition(j,2);
        Z=handles.class1.nodesPosition(j,3);
%         analyze(handles.class1.HorizontalRx,handles.class1.VerticalRx,'bx', 'linewidth', 2, 'markersize', 10)
%         text(1.02*handles.class1.HorizontalRx, handles.class1.VerticalRx, 'RX')
        set(gca,'zdir','reverse') % IF 3D
        plot3(X,Y,Z,'bx', 'linewidth', 2, 'markersize', 10);
        text(1.02*X, Y,Z, 'RX')
       end
%         subplot(1,5,1)
%          axis([ 0,handles.class1.Rx(2), -1, max(handles.settings.SSP_z) ] )
% xlim([0, handles.class1.Rx(2)])
% ylim([-1, max(handles.settings.SSP_z)])
%         axis auto
     
%     axis([ 0,max(handles.class1.Rx(:,1)), -1-max(handles.class1.Rx(:,2)), +1+max(handles.class1.Rx(:,2)),0,handles.class1.depth]  )
    
     xlim([0,max(handles.class1.nodesPosition(:,1))+50]);
     ylim([-1-max(abs(handles.class1.nodesPosition(:,2))), +1+max(abs(handles.class1.nodesPosition(:,2)))]);
    zlim([0,handles.class1.depth]);
    set(gca,'zdir','reverse') % IF 3D 
    hold off 
    
    axes(handles.axes2);
%         analyze(sspu_ds,depu_ds)
    plot(handles.settings.SSP,handles.settings.SSP_z)
    grid on
    axis ij
    ylim([-1 max(handles.settings.SSP_z)])
    xlabel('Sound Speed - m/s')
    ylabel('Depth - m')
    
    hold off 
    waitbar(4/5)
cd (pathGUI)
 
else
    waitbar(4/5)
    if handles.statement.firstTime==1 
        %%%% Default %%%% Or the previous don't need to reDraw!!
        %         handles.class1.HorizontalRx=handles.class1.Rx(i,1); % X-2D
        %         handles.class1.Ydirections=handles.class1.Rx(i,2);
        %         handles.class1.VerticalRx=handles.class1.Rx(i,3); % Z
        handles.statement.firstTime=0;
        handles.class1.HorizontalTx=handles.class1.nodesChannel(1,1); % Horizontal TX
        handles.class1.VerticalTx= handles.class1.nodesChannel(1,2); % Vertical TX
        handles.class1.RealDistanceRX= handles.class1.nodesChannel(1,3); % Real distance RX
        handles.class1.VerticalRx = handles.class1.nodesChannel(1,4); % Vertical RX
        handles.class1.Ydirections = handles.class1.nodesChannel(1,5); % Y-direction RX 
        handles.class1.HorizontalRX= handles.class1.nodesChannel(1,6); % Horizontal Position RX 
        handles.class1.YTx = handles.class1.nodesChannel(1,7); % Y-direction TX
        handles.class1.ActualHorizontalRX= handles.class1.nodesChannel(1,8);
        
        [ Arr, Pos ] = read_arrivals_asc(handles.settings.filenameArr);
        handles.settings.nArrival{1} = Arr;
        handles.settings.Pos = Pos;
        fid = fopen(handles.settings.filenameArr,'r');
        TITLE  = fgetl(  fid );
        FREQ   = fscanf( fid, '%f', 1 );
        NBEAMS = fscanf( fid, '%i', 1 );
        DEPTHT = fscanf( fid, '%f', 1 );
        %     handles.class1.depth = fscanf( fid, '%f', 1 );
        
        [handles.settings.SSP, handles.settings.SSP_z]=readSpeedAndDepth(handles.settings.filenameSoundSpeed);
        axes(handles.axes1);
        plotray( handles.settings.filenameRay,handles);
        plotati2(handles)
        hold on
        X=handles.class1.RealDistanceRX;
        Y=handles.class1.Ydirections;
        Z=handles.class1.VerticalRx;
        
        plot3(X,Y,Z,'bx', 'linewidth', 2, 'markersize', 10);
        text(1.02*X, Y,Z, 'RX')
        xlim([0,max(handles.class1.nodesPosition(:,1))+max(handles.class1.nodesChannel(:,1))]);
        ylim([-1-max(abs(handles.class1.nodesPosition(:,2))), +1+max(abs(handles.class1.nodesPosition(:,2)))]);
        zlim([0,handles.class1.depth]);
        
        set(gca,'zdir','reverse') % IF 3D
        axes(handles.axes2);
        %         analyze(sspu_ds,depu_ds)
        plot(handles.settings.SSP,handles.settings.SSP_z)
        axis ij
        ylim([-1 max(handles.settings.SSP_z)])
        xlabel('Sound Speed - m/s')
        ylabel('Depth - m')
        grid on
        hold off
        
        
    end
%     xlim([0,max(handles.class1.Rx(:,1))]);
%     ylim([-1-max(handles.class1.Rx(:,2)), +1+max(handles.class1.Rx(:,2))]);
%     zlim([0,handles.class1.depth]);
%     set(gca,'zdir','reverse') % IF 3D
%     hold off
%     
%     axes(handles.axes2);
%     %         analyze(sspu_ds,depu_ds)
%     plot(handles.settings.SSP,handles.settings.SSP_z)
%     axis ij
%     ylim([-1 max(handles.settings.SSP_z)])
%     xlabel('Sound Speed - m/s')
%     ylabel('Depth - m')
%     hold off
    
end

cd (pathFunc)



% Doppler 
% Doppler % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

waitbar(5/5)
close(handles.plot.waitbar)

 
% save the distances from Raytracing into handles class.
loopS = length(handles.settings.nArrival);

% currentMin = min(handles.settings.nArrival{1}.delay(1:handles.settings.nArrival{1}.Narr));
% handles.settings.firstArrival = currentMin;
tempMin = 100;
for l = 1:loopS
    currentMin = min(handles.settings.nArrival{l}.delay(1:handles.settings.nArrival{l}.Narr));
    
    if tempMin > currentMin
        handles.settings.firstArrival = currentMin;
        tempMin = currentMin;
    end
end
% handles.settings.firstArrival = min(handles.settings.nArrival{1}.delay(1:handles.settings.nArrival{1}.Narr));


% Error for horizontal distance, cause of latency
if (handles.settings.firstArrival*1000<min(ms))
    str=num2str(min(minDist));
    str=['Minimum distance between the transducers is : ' str ' m'];
    errordlg(str,'Error');
end

cd (pathGUI)


%%%%%%%%%%%%%%%%%%%%%%% Initialize the soundcard %%%%%%%%%%%%%%%%%%%%%%

% Get framesize, based on distance between RX and TX. 

L=length(ms);
for i = 1: L-1
    if ms(i)/1000<handles.settings.firstArrival && handles.settings.firstArrival<=ms(i+1)/1000
        nSampl=samplesDelay(i);
        handles.settings.samplesPerFrame=SamplesPerFrame(i);
    elseif handles.settings.firstArrival>ms(L-1)/1000
        nSampl = samplesDelay(L);
        handles.settings.samplesPerFrame=SamplesPerFrame(L);
    end
end

cd (pathFunc)
% Create sound Options
[handles.settings.Speaker, handles.settings.Mic]=CreateSpeakerAndMic(handles.settings.soundcard, ...
    handles.settings.Fs, handles.settings.samplesPerFrame, handles.settings.numbOfInOut);
    
% handles.t.transducergain= zeros(1,2*length(handles.class1.dist));
handles.t.transducergain= zeros(1,handles.settings.Arr{1}.Narr);
% change to  handles.settings.nArrival!! 



if handles.statement.loadTransSens==1

    if (handles.settings.carrierF==21)
        handles.t.transmitterSens=handles.t.sensitivtyData(2,2)';
        handles.t.receiverSens=handles.t.sensitivtyData(2,3)';
        handles.t.transducerImp=handles.t.sensitivtyData(2,4)';
        handles.t.transducerPhaseDeg=handles.t.sensitivtyData(2,5)';
    elseif (handles.settings.carrierF==26)
        handles.t.transmitterSens=handles.t.sensitivtyData(7,2)';
        handles.t.receiverSens=handles.t.sensitivtyData(7,3)';
        handles.t.transducerImp=handles.t.sensitivtyData(7,4)';
        handles.t.transducerPhaseDeg=handles.t.sensitivtyData(7,5)';
    elseif (handles.settings.carrierF==31)
        handles.t.transmitterSens=handles.t.sensitivtyData(13,2)';
        handles.t.receiverSens=handles.t.sensitivtyData(13,3)';
        handles.t.transducerImp=handles.t.sensitivtyData(13,4)';
        handles.t.transducerPhaseDeg=handles.t.sensitivtyData(13,5)';
    end
    set(handles.TransducerSensDisp, 'String',  [num2str(handles.t.transmitterSens) ' [dB/V ]']);
    set(handles.ReceiverSensDisp, 'String', [num2str(handles.t.receiverSens) ' [V/dB]']);
end

headerRealTime
% Pick out reflections with 20 dB less amplitude than max amplitude
amplitudeLimitSelection
 
for i=1:nChannels %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5 
    handles.settings.nArrival{i}.A=amplitudeWithSens(handles,i);
end

if (handles.statement.loadTrans==1)
    % changes the amplitude hence to transducer data! 
    [handles] = transducerAngleGain(handles); 
    degree = handles.settings.angle{1}(ceil(handles.settings.nArrival{1}.Narr/2));
    % only changing the tilt to node number 1
    degrees = num2str(degree);
    degrees=strcat(degrees,char(176));
    set(handles.TransducerAngleDir, 'String', degrees);
    handles.t.transducergain= reshape(handles.settings.gain{1},1,[]);
end
% cd (pathFunc)
handles.settings.noise = ambientNoise(handles);
% cd (pathGUI)
% Create channel matrix

% M FIKSES ! 
% % % % % % % % % % % % % % % % % % % % % % % 
[handles.settings.matrix, handles.settings.intensity] = channelMatrix(handles);


% handles.t.transducergain = reshape(handles.settings.gain,1,[]);
cd ('Results')

fid = fopen([filnam 'Results.txt'], 'w');

for i=1:handles.class1.nChannel
    Results= handles.settings.nArrival{i};
    fprintf(fid, '\n \t RESULTS FOR CHANNEL %i     : \t',i); %(Node %i - Node %i) '\t', i, handles.class1.nodeTree );
    
    fprintf(fid, '\n \t Amplitude                 : \t');
    Length=length(Results.A);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %.04g \t', Results.A(j));
    end
    
    fprintf(fid, '\n \t Delay                     : \t');
    Length=length(Results.delay);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %.04g \t', 1000.*Results.delay(j));
    end
    
    fprintf(fid, '\n \t Transmit Angle            : \t');
    Length=length(Results.SrcAngle);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %.04g \t', Results.SrcAngle(j));
    end
    
    fprintf(fid, '\n \t Receive Angle             : \t');
    Length=length(Results.RcvrAngle);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %.04g \t', Results.RcvrAngle(j));
    end
    
    fprintf(fid, '\n \t Number of Surface Bounces : \t');
    Length=length(Results.NumTopBnc);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %i \t', Results.NumTopBnc(j));
    end
    
    fprintf(fid, '\n \t Number of Bottom Bounces  : \t');
    Length=length(Results.NumBotBnc);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %i \t', Results.NumBotBnc(j));
    end
    
     fprintf(fid, '\n \t Number of paths : \t \t');
    Length=length(Results.Narr);
    for j = 1:Length % number of nodes
        fprintf(fid, '\t %i \t', Results.Narr(j));
    end
    fprintf(fid, '\n \n \n');
end
fclose(fid);

cd (pathGUI)

assignin('base','handles',handles)
% Send the data global
guidata(hObject,handles)





function depth_Callback(hObject, eventdata, handles)
% hObject    handle to depth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of depth as text
%        str2double(get(hObject,'String')) returns contents of depth as a double
depth = str2double(get(hObject, 'String'));
if isnan(depth)
    set(hObject, 'String', handles.class1.depth);
    hold off 
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.class1.depth = depth;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function depth_CreateFcn(hObject, eventdata, handles)
% hObject    handle to depth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function horizontalRx_Callback(hObject, eventdata, handles)
% hObject    handle to horizontalRx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of horizontalRx as text
%        str2double(get(hObject,'String')) returns contents of horizontalRx as a double
global minDist
horizontalRx = str2double(get(hObject, 'String'));
global ChangedValue
ChangedValue=ChangedValue+1;
if isnan(horizontalRx)
    set(hObject, 'String', handles.class1.horizontal);
    hold off 
    errordlg('Input must be a number','Error');
% elseif horizontalRx < minDist
%     str =[ 'Range must be larger than minimum distance: ', num2str(min(minDist)) 'm'];
%     errordlg(str,'Error');
end
    
% Save the new density value
handles.class1.nodesPosition(2,1) =horizontalRx;
handles.class1.nodesDistance2D(2,1)=horizontalRx; % DELETE ?? 
handles.class1.nodesChannel(1,3)=horizontalRx;
handles.class1.nodesChannel(1,6)=horizontalRx;
handles.class1.nodesChannel(1,8)=horizontalRx;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function horizontalRx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to horizontalRx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function verticalRx_Callback(hObject, eventdata, handles)
% hObject    handle to verticalRx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of verticalRx as text
%        str2double(get(hObject,'String')) returns contents of verticalRx as a double
verticalRx = str2double(get(hObject, 'String'));
global ChangedValue depth
ChangedValue=ChangedValue+1;
if isnan(verticalRx)
    hold off 
    set(hObject, 'String', handles.class1.vertical);
    errordlg('Input must be a number','Error');
    
elseif verticalRx>=depth
    str=['To deep, minimum ' num2str(depth) 'm  deep'];
    errordlg(str,'Error');
    set(handles.verticalRx,  'String', handles.class1.nodesPosition(2,3));
    return
end

% Save the new density value
% handles.class1.Rx(1,3) = verticalRx;
% handles.class1.Rx2D(1,2) = verticalRx;

handles.class1.nodesPosition(2,3) =verticalRx;
handles.class1.nodesChannel(1,4)=verticalRx;

guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function verticalRx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to verticalRx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function numberOfReflections_Callback(hObject, eventdata, handles)
% hObject    handle to numberOfReflections (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numberOfReflections as text
%        str2double(get(hObject,'String')) returns contents of numberOfReflections as a double
global ChangedValue
ChangedValue=ChangedValue+1;
numberOfReflections = str2double(get(hObject, 'String'));
if isnan(numberOfReflections)
    set(hObject, 'String', handles.class1.numberOfReflections);
    hold off 
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.class1.numberOfReflections = numberOfReflections;
guidata(hObject,handles)
% Ouput handles.
assignin('base','handles',handles)


% --- Executes during object creation, after setting all properties.
function numberOfReflections_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numberOfReflections (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function verticalTx_Callback(hObject, eventdata, handles)
% hObject    handle to verticalTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of verticalTx as text
%        str2double(get(hObject,'String')) returns contents of verticalTx as a double
verticalTx = str2double(get(hObject, 'String'));
global ChangedValue depth
ChangedValue=ChangedValue+1;
if isnan(verticalTx)
    set(hObject, 'String', handles.class1.VerticalTx);
    hold off
    errordlg('Input must be a number','Error');
elseif verticalTx>=depth
    str=['To deep, minimum ' num2str(depth) 'm  deep'];
    errordlg(str,'Error');
    set(handles.verticalTx,  'String', handles.class1.VerticalTx);
    return
end

% Save the new density value
handles.class1.VerticalTx = verticalTx;
handles.class1.nodesChannel(1,2)=verticalTx;
handles.class1.nodesPosition(1,3)=verticalTx;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function verticalTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to verticalTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function salinity_Callback(hObject, eventdata, handles)
% hObject    handle to salinity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of salinity as text
%        str2double(get(hObject,'String')) returns contents of salinity as a double
Salinity = str2double(get(hObject, 'String'));
if isnan(Salinity)
    set(hObject, 'String', handles.class1.VerticalTx);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.settings.Salinity = Salinity;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function salinity_CreateFcn(hObject, eventdata, handles)
% hObject    handle to salinity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function temperature_Callback(hObject, eventdata, handles)
% hObject    handle to temperature (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of temperature as text
%        str2double(get(hObject,'String')) returns contents of temperature as a double
temperature = str2double(get(hObject, 'String'));
if isnan(temperature)
    set(hObject, 'String', handles.class1.temperature);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.settings.temp = temperature;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function temperature_CreateFcn(hObject, eventdata, handles)
% hObject    handle to temperature (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function transmittVoltage_Callback(hObject, eventdata, handles)
% hObject    handle to transmittVoltage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of transmittVoltage as text
%        str2double(get(hObject,'String')) returns contents of transmittVoltage as a double


% --- Executes during object creation, after setting all properties.
function transmittVoltage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transmittVoltage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu6.
function popupmenu6_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu6 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu6


% --- Executes during object creation, after setting all properties.
function popupmenu6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function transducerAngle_Callback(hObject, eventdata, handles)
% hObject    handle to transducerAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of transducerAngle as text
%        str2double(get(hObject,'String')) returns contents of transducerAngle as a double
transAng = str2double(get(hObject, 'String'));
if isnan(transAng)
    set(hObject, 'String', handles.t.transAng);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.t.transAng = transAng;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function transducerAngle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transducerAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in attenuationSea.
function attenuationSea_Callback(hObject, eventdata, handles)
% hObject    handle to attenuationSea (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of attenuationSea

handles.statement.absorption = get(hObject,'Value');
guidata(hObject,handles)
assignin('base','handles',handles)

% --- Executes on selection change in chooseSoundCard.
function chooseSoundCard_Callback(hObject, eventdata, handles)
% hObject    handle to chooseSoundCard (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns chooseSoundCard contents as cell array
%        contents{get(hObject,'Value')} returns selected item from chooseSoundCard

% Loads all the items from the pop-up menu
items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
handles.settings.soundcard = items{index_selected};

display(handles.settings.soundcard);

% Send the data global
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function chooseSoundCard_CreateFcn(hObject, eventdata, handles)
% hObject    handle to chooseSoundCard (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',{'default','UA-25','OCTA-CAPTURE'});

% --- Executes on selection change in samplingFreq.
function samplingFreq_Callback(hObject, eventdata, handles)
% hObject    handle to samplingFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns samplingFreq contents as cell array
%        contents{get(hObject,'Value')} returns selected item from samplingFreq
% Loads all the items from the pop-up menu
items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
Fs = items{index_selected};
handles.settings.Fs=str2double(Fs);
display(handles.settings.Fs);

% Send the data global
assignin('base','handles',handles)
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function samplingFreq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to samplingFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',{'44100','48000','96000','192000'});


% --- Executes on selection change in numberOfCh.
% function numberOfCh_Callback(hObject, eventdata, handles)
% % hObject    handle to numberOfCh (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hints: contents = cellstr(get(hObject,'String')) returns numberOfCh contents as cell array
% %        contents{get(hObject,'Value')} returns selected item from numberOfCh
% % Loads all the items from the pop-up menu
% items = get(hObject,'String');
% % Get the number value from the list
% index_selected = get(hObject,'Value');
% % Get the number from the list.
% numberOfChannels = items{index_selected};
% handles.settings.numberOfChannels=str2double(numberOfChannels);
% 
% display(handles.settings.numberOfChannels);
% % Send the data global
% guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function numberOfCh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numberOfCh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String',{'2','3','4','5','6','7','8'})

% --- Executes on button press in delayPropagation.
function delayPropagation_Callback(hObject, eventdata, handles)
% hObject    handle to delayPropagation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of delayPropagation
% handles.settings.propTrue=handles.settings.propTrue+1;

handles.statement.propTrue = get(hObject,'Value');

assignin('base','handles',handles);
guidata(hObject,handles)

% --- Executes on selection change in seastate.
function seastate_Callback(hObject, eventdata, handles)
global  pathFunc pathGUI
% hObject    handle to seastate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns seastate contents as cell array
%        contents{get(hObject,'Value')} returns selected item from seastate

% Loads all the items from the pop-up menu
% items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
% seastate = items{index_selected};
handles.settings.seastate=index_selected-1;
global ChangedValue
ChangedValue=ChangedValue+1;
display(handles.settings.seastate);



cd (pathFunc)
handles.settings.noise = ambientNoise(handles);
cd (pathGUI)
WindSpeed={'<0.3 m/s', '0.3-1.5 m/s', '3.3-5.5 m/s', '5.5-8 m/s', ...
    '8-10.8 m/s', '10.8-13.9 m/s', '13.9-17.2 m/s', '17.2-20.7 m/s', ...
    '24.5-28.4 m/s', '28.4-32.6 m/s', '>32.6 m/s'};
set(handles.WindSpeed, 'String', WindSpeed{index_selected})

assignin('base','handles',handles);
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function seastate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to seastate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String',{'0 [0 m]','1 [0 - 0.1 m]','2 [0.1 - 0.5 m]','3 [0.5 - 1.25 m]','4 [1.25 - 2.5 m]','5 [2.5 - 4 m]','6 [4 - 6 m]','7 [6 - 9 m]','8 [9 - 14 m]','9 [14 m-> '});


% --- Executes on selection change in ReflectionLoss.
function ReflectionLoss_Callback(hObject, eventdata, handles)
global  pathFunc pathGUI
% hObject    handle to ReflectionLoss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns ReflectionLoss contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ReflectionLoss

% Loads all the items from the pop-up menu
items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
reflectionCase = items{index_selected};

% 3 Cases for reflection loss 
if (strcmp(reflectionCase, 'Soft'))
    handles.settings.reflectionCase=1;
elseif (strcmp(reflectionCase, 'Medium'))
    handles.settings.reflectionCase=2;
elseif (strcmp(reflectionCase, 'Hard'))
    handles.settings.reflectionCase=3;
end

display(handles.settings.reflectionCase);



cd (pathFunc)

disp('ReflectionLoss')
[RL,phaseChange] = reflectionLoss(handles);
handles.settings.RL=RL;
handles.settings.phaseChange=phaseChange;

cd (pathGUI)

assignin('base','handles',handles);
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ReflectionLoss_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ReflectionLoss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',{'Soft','Medium','Hard'});


% --- Executes during object creation, after setting all properties.
function SoundSpeedView_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SoundSpeedView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in Analyze.
function Analyze_Callback(hObject, eventdata, handles)
global filename pathnam filnam pathGUI pathFunc
% % hObject    handle to Analyze (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% % close all
% 

[menu3]=AnalyzeGUI(handles); % Get the data from GUI 
handles.menu3=menu3;
assignin('base','menu3',handles.menu3)

guidata(hObject,handles)

% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in carrierFrequency.
function carrierFrequency_Callback(hObject, eventdata, handles)
% hObject    handle to carrierFrequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA) 

% Hints: contents = cellstr(get(hObject,'String')) returns carrierFrequency contents as cell array
%        contents{get(hObject,'Value')} returns selected item from carrierFrequency
% Loads all the items from the pop-up menu
global ChangedValue
ChangedValue=ChangedValue+1;
items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
carrierF = items{index_selected};
handles.settings.carrierF=str2double(carrierF);
display(handles.settings.carrierF);
% Send the data global
assignin('base','handles',handles);
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function carrierFrequency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to carrierFrequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String',{'21','26','31'});


% --- Executes on button press in Multipaths.
function Multipaths_Callback(hObject, eventdata, handles)
% hObject    handle to Multipaths (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Multipaths
global reflections;
reflections=get(hObject,'Value');

assignin('base','handles',handles);
guidata(hObject,handles)


% --- Executes on button press in LoadSpeedProfile.
function LoadSpeedProfile_Callback(hObject, eventdata, handles)
% hObject    handle to LoadSpeedProfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global pathFunc pathGUI ChangedValue depth
cd(pathFunc)
writeBellhopInput(); % Load Sound speed profile
global returnTrue
if returnTrue==0
    [SSP,SSP_z]=readSpeedAndDepth('tmpssp.txt');
    handles.settings.SSP=SSP;
    handles.settings.SSP_z=SSP_z;
    handles.class1.depth=max(SSP_z);
    set(handles.depth,  'String', max(handles.settings.SSP_z));
    
    axes(handles.axes2);
	

    plot(SSP,SSP_z)
    axis ij
    grid on
    ylim([min(SSP_z) max(SSP_z)])
    xlabel('Sound Speed - m/s')
    ylabel('Depth - m')
    depth = max(SSP_z);
    ChangedValue=ChangedValue+1;
else 
    returnTrue=0;
end


% if (length(SSP)>1)
% else
%     str=num2str(min(minDist));
%     str=['Minimum distance between the transducers is : ' str ' m'];
%     errordlg(str,'Error');
% end



% axes(handles.axes2);
% % axis ij
% 
% plot(SSP,SSP_z)
% axis ij
% grid on
% ylim([min(SSP_z) max(SSP_z)])
% xlabel('Sound Speed - m/s')
% ylabel('Depth - m')
cd(pathGUI)
% depth = max(SSP_z);
assignin('base','handles',handles);
guidata(hObject,handles)

% --- Executes on selection change in Seabed.
function Seabed_Callback(hObject, eventdata, handles)
% hObject    handle to Seabed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Seabed contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Seabed
% Loads all the items from the pop-up menu
items = get(hObject,'String');
% Get the number value from the list
index_selected = get(hObject,'Value');
% Get the number from the list.
seabed = items{index_selected};
global ChangedValue
ChangedValue=ChangedValue+1;
% 6 Cases for seabed 
if (strcmp(seabed, 'Flat'))
    handles.settings.seabed=0;
    handles.settings.heightSeabedChange=0;
elseif (strcmp(seabed, 'Slowly varying sine'))
    handles.settings.seabed=1;
%     handles.settings.heightSeabedChange=0;
elseif (strcmp(seabed, 'Rapidly varying sine'))
    handles.settings.seabed=2;
%     handles.settings.heightSeabedChange=0;
elseif (strcmp(seabed, 'Gaussian'))
    handles.settings.seabed=3;
%     handles.settings.heightSeabedChange=0;
elseif (strcmp(seabed, 'Linear decreasing'))
    handles.settings.seabed=4;
    handles.settings.heightSeabedChange=20;
elseif (strcmp(seabed, 'Linear increasing'))
    handles.settings.seabed=5;
    handles.settings.heightSeabedChange=20;
end

assignin('base','handles',handles);
guidata(hObject,handles)
display(handles.settings.seabed);

% --- Executes during object creation, after setting all properties.
function Seabed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Seabed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String',{'Flat' 'Slowly varying sine' 'Rapidly varying sine' 'Gaussian' 'Linear increasing' 'Linear decreasing'}); 



% --- Executes on button press in intensityPlot.
function intensityPlot_Callback(hObject, eventdata, handles)
% hObject    handle to intensityPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of intensityPlot
global intensityTrue
intensityTrue=intensityTrue+1;
global ChangedValue
ChangedValue=ChangedValue+1;

% --- Executes on selection change in SeaSurface.

function SeaSurface_Callback(hObject, eventdata, handles)
% hObject    handle to SeaSurface (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns SeaSurface contents as cell array
%        contents{get(hObject,'Value')} returns selected item from SeaSurface
global ChangedValue
ChangedValue=ChangedValue+1;

% --- Executes during object creation, after setting all properties.
function SeaSurface_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SeaSurface (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function DopplerSweepSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to DopplerSweepSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DopplerSweepSpeed as text
%        str2double(get(hObject,'String')) returns contents of DopplerSweepSpeed as a double


% --- Executes during object creation, after setting all properties.
function DopplerSweepSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DopplerSweepSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function DopplerSweepDist_Callback(hObject, eventdata, handles)
% hObject    handle to DopplerSweepDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DopplerSweepDist as text
%        str2double(get(hObject,'String')) returns contents of DopplerSweepDist as a double


% --- Executes during object creation, after setting all properties.
function DopplerSweepDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DopplerSweepDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in DopplerSpread.
function DopplerSpread_Callback(hObject, eventdata, handles)
% hObject    handle to DopplerSpread (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ChangedValue
ChangedValue=ChangedValue+1;



% handles.statement.DopplerSpread = rem(handles.statement.DopplerSpread+1,2);
handles.statement.DopplerSpread = get(hObject,'Value');

guidata(hObject,handles)
assignin('base','handles',handles)
% Hint: get(hObject,'Value') returns toggle state of DopplerSpread



function FilenameInput_Callback(hObject, eventdata, handles)
% hObject    handle to FilenameInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FilenameInput as text
%        str2double(get(hObject,'String')) returns contents of FilenameInput as a double


% --- Executes during object creation, after setting all properties.
function FilenameInput_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FilenameInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in NumberOfChannels.
function NumberOfChannels_Callback(hObject, eventdata, handles)
% hObject    handle to NumberOfChannels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns NumberOfChannels contents as cell array
%        contents{get(hObject,'Value')} returns selected item from NumberOfChannels
% Loads all the items from the pop-up menu

global ChangedValue
ChangedValue=ChangedValue+1;

% Go to new GUI, ChannelsGUI, which make the use to input channels.
[menu2]=ChannelsGUI(handles); % Get the data from GUI
% Use "Global" method, maybe easier!  
disp('menu2')
disp(menu2)
disp(menu2.data)

numOfch=0;
% DELETE THIS WHEN 3D WORKS ! 
handles.class1.Rx=[];
handles.class1.Rx2D=[];
%%%%%%%%%%%%%%%%%%%%%%%%%%
handles.class1.nodesPosition=[];
handles.class1.nodesDistance2D=[];
handles.class1.nodesChannel=[];
handles.class1.Rx2D= zeros(6,2);

for i=1:6 % iterate through the nodes
    if menu2.check(i)==1  % if nodes equal true
        numOfch=numOfch+1;
        
        % DELETE THIS WHEN 3D WORKS ! 
        handles.class1.Rx(numOfch,1)=menu2.data(i,1); % X 
        handles.class1.Rx(numOfch,2)=menu2.data(i,2); % Y
        handles.class1.Rx(numOfch,3)=menu2.data(i,3); % Z
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        handles.class1.nodesPosition(numOfch,1)=menu2.data(i,1); % X 
        handles.class1.nodesPosition(numOfch,2)=menu2.data(i,2); % Y
        handles.class1.nodesPosition(numOfch,3)=menu2.data(i,3); % Z 
    end
end
nodes= sum(menu2.check==1);
mat = zeros(nodes);
iterate=0;
for i = 1:nodes
    iterate2 = i; 
    for j = 1:nodes
        if (i<j)
            iterate = iterate+1;
            iterate2 = iterate2+1;
            handles.class1.networkTree(i,j)=j;
            mat(i,j) = sqrt((menu2.data(i,1)-menu2.data(j,1))^2 + ...
            (menu2.data(i,2)-menu2.data(j,2))^2 ); %+ (menu2.data(i,3)-menu2.data(j,3))^2
        
            handles.class1.nodesChannel(iterate,1)=menu2.data(i,1); % Horizontal TX
            handles.class1.nodesChannel(iterate,2)=menu2.data(i,3); % vertical TX
            handles.class1.nodesChannel(iterate,3)=sqrt((menu2.data(i,1)-menu2.data(j,1))^2 + ...
            (menu2.data(i,2)-menu2.data(j,2))^2 ); % Actual distance -RX
            
            handles.class1.nodesChannel(iterate,4)=menu2.data(j,3); %vertical RX
            handles.class1.nodesChannel(iterate,7)=menu2.data(i,2); 
            
            handles.class1.nodesChannel(iterate,5)=menu2.data(j,2);
            %             if menu2.data(i,1)>menu2.data(i+1,1)
%                 handles.class1.nodesChannel(iterate,5)=-menu2.data(j,2); %Y-direction RX 
% %             tempPosition(iterate,1)=menu2.data(j,1);
%             else
%                 handles.class1.nodesChannel(iterate,5)=menu2.data(j,2); %Y-direction RX   
%             end
            
            if i<nodes
                handles.class1.nodesChannel(iterate,6)=menu2.data(iterate2,1)-menu2.data(i,1); % Horizontal distance RX
                handles.class1.nodesChannel(iterate,8)=menu2.data(iterate2,1); % ACTUAL RX DISTANCE
                %             handles.class1.nodesChannel(iterate,5)=menu2.data(iterate2,2)-menu2.data(i,2); % Y-direction 
            
            end
        end
    end
end
handles.settings.nodes=nodes;

handles.class1.nodesDistance2D=mat;

handles.settings.numbOfInOut=numOfch; % sound card


%set the statements at the GUI
set(handles.horizontalRx,  'String', handles.class1.nodesPosition(2,1));
set(handles.verticalRx, 'String', handles.class1.nodesPosition(2,3));

guidata(hObject,handles)
assignin('base','handles',handles)
assignin('base','menu2',menu2)


% --- Executes during object creation, after setting all properties.
function NumberOfChannels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NumberOfChannels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function TransducerSensDisp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TransducerSensDisp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes on button press in DopplerShift.
function DopplerShift_Callback(hObject, eventdata, handles)
% hObject    handle to DopplerShift (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of DopplerShift
FreqShift(handles);



% --- Executes on button press in ManualShapeSeabottom.
function ManualShapeSeabottom_Callback(hObject, eventdata, handles)
% hObject    handle to ManualShapeSeabottom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global pathFunc pathGUI  ChangedValue
cd (pathFunc)
ChangedValue=ChangedValue+1;

figure
[obj,x,z]=freehanddraw; %freehanddraw(gca,'color','r','linewidth',3)
handles.settings.handdrawX=x;
handles.settings.handdrawZ=z;
handles.settings.seabed=10;

cd (pathGUI)
guidata(hObject,handles)
assignin('base','handles',handles)

% --- Executes on button press in ManualSeabottom.
function ManualSeabottom_Callback(hObject, eventdata, handles)
% hObject    handle to ManualSeabottom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
SeabedMaterialGUI(handles)
str  = [num2str(handles.settings.densBottom1) ' g/cm^3'];
str2 = [num2str(handles.settings.cBottom1), ' m/s'];
set(handles.SeabedDensity, 'String', str);
set(handles.SeabedSpeed, 'String', str2);
% --- Executes on button press in RecordData.
function RecordData_Callback(hObject, eventdata, handles)
% hObject    handle to RecordData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RecordData
global ChangedValue
ChangedValue=ChangedValue+1;
handles.statement.RecordData=get(hObject,'Value');
guidata(hObject,handles)
assignin('base','handles',handles)
% --- Executes on button press in Calibration.

function Calibration_Callback(hObject, eventdata, handles)
% hObject    handle to Calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global minDist ChangedValue
ChangedValue=ChangedValue+1;
Calibration(handles)
set(handles.MinDist, 'String', num2str(min(minDist)));

% --- Executes on button press in SpectrumAnalyze.
function SpectrumAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to SpectrumAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SpectrumAnalyze


% --- Executes on button press in ScopeAnalyze.
function ScopeAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to ScopeAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ScopeAnalyze


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_2_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_3_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axes2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes2
