% Refer to p 74 in Hovem, Marin Acoustics. Plotting figure 4.3 and figure
% 4.4. Leo H.
clear all
close all
c1 = 1500;
p1 = 1000;

c2 = 1700;
p2 = 2000;
theta1 = 0:0.01:pi/2;

for i = 1:length(theta1)
    theta2 = acos(c2/c1 * cos(theta1(i)));
    Rp(i) = (c2*p2*sin(theta1(i))-c1*p1*sin(theta2))/((c2*p2*sin(theta1(i))+c1*p1*sin(theta2)));
end
figure
% Rp
angle= theta1.*180./pi;
Tp = Rp +1;
Rp = (Rp);
plot (angle,Rp, 'LineWidth',2)
hold on
plot (angle, Tp, '-- black','LineWidth',2)
hold off
grid on
% ylim([0 3]) 
% intesity 
Ir = abs(Rp).^2;
It = 1 - Ir;
figure 
plot (angle,Ir)
hold on
plot (angle, It, '-- black')
hold off
ylabel('Relative intensityies - I_{ r} and I_{ t}')
xlabel('Grazing angle -deg')
legend('Reflection', 'Transmission')
ylim([0 2])
grid on