function varargout = SeabedMaterialGUI(varargin)
% SEABEDMATERIALGUI MATLAB code for SeabedMaterialGUI.fig
%      SEABEDMATERIALGUI, by itself, creates a new SEABEDMATERIALGUI or raises the existing
%      singleton*.
%
%      H = SEABEDMATERIALGUI returns the handle to a new SEABEDMATERIALGUI or the handle to
%      the existing singleton*.
%
%      SEABEDMATERIALGUI('CALLBACK',hObject,eventData,menu4,...) calls the local
%      function named CALLBACK in SEABEDMATERIALGUI.M with the given input arguments.
%
%      SEABEDMATERIALGUI('Property','Value',...) creates a new SEABEDMATERIALGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SeabedMaterialGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SeabedMaterialGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUImenu4

% Edit the above text to modify the response to help SeabedMaterialGUI

% Last Modified by GUIDE v2.5 20-May-2015 16:58:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SeabedMaterialGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @SeabedMaterialGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SeabedMaterialGUI is made visible.
function SeabedMaterialGUI_OpeningFcn(hObject, eventdata, menu4, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)
% varargin   command line arguments to SeabedMaterialGUI (see VARARGIN)

 defaultValues=[{'1.50-2.60'} {'1500-2500'} {'200-1000'}; {'1.80-2.20'} {'1400-1800'} {'150-450'}; ....
     {'1.60-2.30'} {'1500-2000'} {'100-500'}; {'1.50-2.00'} {'1500-2700'} {'500-1300'}; ...
     {'2.00-3.20'} {'2700-4800'} {'1500-2400'}; ...
     {'2.10-2.80'} {'2100-4500'} {'1200-2800'}; ...
     {'1.60-2.60'} {'2100-4200'} {'1000-2000'}; {'2.10-2.40'} {'4200-5500'} {'2000-3200'}; ...
     {'2.40-3.00'} {'3500-7500'} {'1700-3600'}; {'2.50-2.90'} {'4750-6000'} {'2400-3800'}];
% Choose default command line output for SeabedMaterialGUI
menu4.output = hObject;
menu4.import_parameters = varargin{1};

set(menu4.density1, 'String', menu4.import_parameters.settings.densBottom1);
set(menu4.soundSpeed1, 'String', menu4.import_parameters.settings.cBottom1);
set(menu4.shearWave1, 'String', menu4.import_parameters.settings.csBottom1);

menu4.settings.densBottom1=menu4.import_parameters.settings.densBottom1;
menu4.settings.cBottom1=menu4.import_parameters.settings.cBottom1;
menu4.settings.csBottom1=menu4.import_parameters.settings.csBottom1;

PLOT_Callback(hObject, eventdata, menu4)
% set(menu4.checkbox1, 'Value', 1);
% Update menu4 structure
assignin('base','menu4',menu4)
guidata(hObject, menu4);

% UIWAIT makes SeabedMaterialGUI wait for user response (see UIRESUME)
% uiwait(menu4.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SeabedMaterialGUI_OutputFcn(hObject, eventdata, menu4) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Get default command line output from menu4 structure
varargout{1} = menu4.output;



function density1_Callback(hObject, eventdata, menu4)
% hObject    handle to density1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of density1 as text
%        str2double(get(hObject,'String')) returns contents of density1 as a double
densBottom1 = str2double(get(hObject, 'String'));
if isnan(densBottom1)
    set(hObject, 'String', menu4.settings.densBottom1);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.densBottom1 = densBottom1;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function density1_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to density1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function soundSpeed1_Callback(hObject, eventdata, menu4)
% hObject    handle to soundSpeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of soundSpeed1 as text
%        str2double(get(hObject,'String')) returns contents of soundSpeed1 as a double
soundspeed1 = str2double(get(hObject, 'String'));
if isnan(soundspeed1)
    set(hObject, 'String', menu4.settings.cBottom1);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.cBottom1 = soundspeed1;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function soundSpeed1_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to soundSpeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.




if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function shearWave1_Callback(hObject, eventdata, menu4)
% hObject    handle to shearWave1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of shearWave1 as text
%        str2double(get(hObject,'String')) returns contents of shearWave1 as a double
csBottom1 = str2double(get(hObject, 'String'));
if isnan(csBottom1)
    set(hObject, 'String', menu4.settings.csBottom1);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.csBottom1 = csBottom1;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function shearWave1_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to shearWave1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function depth1_Callback(hObject, eventdata, menu4)
% hObject    handle to depth1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of depth1 as text
%        str2double(get(hObject,'String')) returns contents of depth1 as a double
depthBottom1 = str2double(get(hObject, 'String'));
if isnan(depthBottom1)
    set(hObject, 'String', menu4.settings.depthBottom1);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.depthBottom1 = depthBottom1;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function depth1_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to depth1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function density2_Callback(hObject, eventdata, menu4)
% hObject    handle to density2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of density2 as text
%        str2double(get(hObject,'String')) returns contents of density2 as a double

depthBottom2 = str2double(get(hObject, 'String'));
if isnan(depthBottom2)
    set(hObject, 'String', menu4.settings.depthBottom2);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.depthBottom2 = depthBottom2;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function density2_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to density2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function soundSpeed2_Callback(hObject, eventdata, menu4)
% hObject    handle to soundSpeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of soundSpeed2 as text
%        str2double(get(hObject,'String')) returns contents of soundSpeed2 as a double
cBottom2 = str2double(get(hObject, 'String'));
if isnan(cBottom2)
    set(hObject, 'String', menu4.settings.cBottom2);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.cBottom2 = cBottom2;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function soundSpeed2_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to soundSpeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function shearWave2_Callback(hObject, eventdata, menu4)
% hObject    handle to shearWave2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of shearWave2 as text
%        str2double(get(hObject,'String')) returns contents of shearWave2 as a double
csBottom2 = str2double(get(hObject, 'String'));
if isnan(csBottom2)
    set(hObject, 'String', menu4.settings.csBottom2);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.csBottom2 = csBottom2;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function shearWave2_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to shearWave2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function depth2_Callback(hObject, eventdata, menu4)
% hObject    handle to depth2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of depth2 as text
%        str2double(get(hObject,'String')) returns contents of depth2 as a double
depthBottom2 = str2double(get(hObject, 'String'));
if isnan(depthBottom2)
    set(hObject, 'String', menu4.settings.depthBottom2);
    hold off
    errordlg('Input must be a number','Error');
end

% Save the new density value
menu4.settings.depthBottom2 = depthBottom2;
assignin('base','menu4',menu4)
guidata(hObject,menu4)

% --- Executes during object creation, after setting all properties.
function depth2_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to depth2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, menu4)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, menu4)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2


% --- Executes on button press in OK.
function OK_Callback(hObject, eventdata, menu4)
% hObject    handle to OK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)
close()

% --- Executes on button press in PLOT.
function PLOT_Callback(hObject, eventdata, menu4)
% hObject    handle to PLOT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    structure with menu4 and user data (see GUIDATA)


c1 = 1500; % m/s default soundspeed 
p1 = 1000; % kg/cm3 default density

c2 = menu4.settings.cBottom1; 
p2 = menu4.settings.densBottom1*1000; %kg/cm3
theta1 = 0:0.01:pi/2;

for i = 1:length(theta1)
    theta2 = acos(c2/c1 * cos(theta1(i)));
    Rp(i) = (c2*p2*sin(theta1(i))-c1*p1*sin(theta2))/((c2*p2*sin(theta1(i))+c1*p1*sin(theta2)));
end
% figure
% Rp
angle= theta1.*180./pi;
Tp = Rp +1;
Rp = (Rp);
% % plot (angle,Rp, 'LineWidth',2)
% % hold on
% % plot (angle, Tp, '-- black','LineWidth',2)
% % hold off
% % grid on
ylim([0 3]) 
% intesity 
Ir = abs(Rp).^2;
It = 1 - Ir;
% figure 
plot (angle,Ir)
hold on
plot (angle, It, '-- black')
check=0;
if check==1
    c3 = menu4.settings.cBottom2; 
    p3 = menu4.settings.densBottom2*1000; %kg/cm3
    theta1 = 0:0.01:pi/2;

    for i = 1:length(theta1)
        theta2 = acos(c3/c2 * cos(theta1(i)));
        Rp(i) = (c3*p3*sin(theta1(i))-c2*p1*sin(theta2))/((c3*p3*sin(theta1(i))+c2*p1*sin(theta2)));
    end
    % figure
    % Rp
    angle= theta1.*180./pi;
    Tp = Rp +1;
    Rp = (Rp);
    % % plot (angle,Rp, 'LineWidth',2)
    % % hold on
    % % plot (angle, Tp, '-- black','LineWidth',2)
    % % hold off
    % % grid on
    ylim([0 3]) 
    % intesity 
    Ir = abs(Rp).^2;
    It = 1 - Ir;
    % figure 
    plot (angle,Ir)
    hold on
    plot (angle, It, '-- black')
end


hold off
ylim([0 1.5])
xlim([0 90])
ylabel('Coefficient')
xlabel('Grazing angle')
legend('Reflection Coefficient' ,'Transmission Coefficient')
grid on
% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, menu4)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% menu4    empty - menu4 not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1


% --- Executes on key press with focus on uitable1 and none of its controls.
function uitable1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uitable1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object deletion, before destroying properties.
function uitable1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
